/* ****************************************************************************
 *
 * Copyright (c) Microsoft Corporation. 
 *
 * This source code is subject to terms and conditions of the Microsoft Permissive License. A 
 * copy of the license can be found in the License.html file at the root of this distribution. If 
 * you cannot locate the  Microsoft Permissive License, please send an email to 
 * ironruby@microsoft.com. By using this source code in any fashion, you are agreeing to be bound 
 * by the terms of the Microsoft Permissive License.
 *
 * You must not remove this notice, or any other, from this software.
 *
 *
 * ***************************************************************************/
namespace Ruby.Builtins {
    internal sealed partial class BuiltinsInitializer : Ruby.Builtins.LibraryInitializer {
        protected override void LoadModules() {
            Context.RegisterObjectAndKernel(new System.Action<Ruby.Builtins.RubyModule>(LoadObject), new System.Action<Ruby.Builtins.RubyModule>(LoadKernel));
            
            
            RegisterModule("Errno", typeof(Ruby.Builtins.Errno), new System.Action<Ruby.Builtins.RubyModule>(LoadErrno), Ruby.Builtins.RubyModule.EmptyArray);
            RegisterModule("Math", typeof(Ruby.Builtins.Math), new System.Action<Ruby.Builtins.RubyModule>(LoadMath), Ruby.Builtins.RubyModule.EmptyArray);
            Ruby.Builtins.RubyModule def12 = RegisterModule("Comparable", typeof(Ruby.Builtins.Comparable), new System.Action<Ruby.Builtins.RubyModule>(LoadComparable), Ruby.Builtins.RubyModule.EmptyArray);
            Ruby.Builtins.RubyModule def1 = RegisterModule("Enumerable", typeof(Ruby.Builtins.Enumerable), new System.Action<Ruby.Builtins.RubyModule>(LoadEnumerable), Ruby.Builtins.RubyModule.EmptyArray);
            RegisterClass("String", typeof(System.String), new System.Action<Ruby.Builtins.RubyModule>(LoadString), Context.ObjectClass, new Ruby.Builtins.RubyModule[] {def12, def1, }, null);
            RegisterClass("Array", typeof(System.Collections.Generic.List<System.Object>), new System.Action<Ruby.Builtins.RubyModule>(LoadArray), Context.ObjectClass, new Ruby.Builtins.RubyModule[] {def1, }, new System.Delegate[] {
                new Microsoft.Scripting.Function<System.Collections.Generic.List<System.Object>>(Ruby.Builtins.ArrayOps.Create),
                new Microsoft.Scripting.Function<System.Collections.Generic.List<System.Object>>(Ruby.Builtins.ArrayOps.CreateArray),
                new Microsoft.Scripting.Function<System.Int32, System.Object, System.Collections.Generic.List<System.Object>>(Ruby.Builtins.ArrayOps.CreateArray),
                new Microsoft.Scripting.Function<System.Int32, System.Collections.Generic.List<System.Object>>(Ruby.Builtins.ArrayOps.CreateArray),
                new Microsoft.Scripting.Function<System.Object, System.Collections.Generic.List<System.Object>>(Ruby.Builtins.ArrayOps.CreateArray),
                new Microsoft.Scripting.Function<System.Object, System.Object, System.Collections.Generic.List<System.Object>>(Ruby.Builtins.ArrayOps.CreateArray),
                new Microsoft.Scripting.Function<System.Collections.Generic.List<System.Object>, System.Collections.Generic.List<System.Object>>(Ruby.Builtins.ArrayOps.CreateArray),
                new Microsoft.Scripting.Function<Ruby.Builtins.Proc, System.Int32, System.Collections.Generic.List<System.Object>>(Ruby.Builtins.ArrayOps.CreateArray),
            });
            RegisterClass("Hash", typeof(System.Collections.Generic.Dictionary<System.Object, System.Object>), new System.Action<Ruby.Builtins.RubyModule>(LoadHash), Context.ObjectClass, new Ruby.Builtins.RubyModule[] {def1, }, null);
            Ruby.Builtins.RubyClass def9 = RegisterClass("Numeric", typeof(Ruby.Builtins.Numeric), new System.Action<Ruby.Builtins.RubyModule>(LoadNumeric), Context.ObjectClass, new Ruby.Builtins.RubyModule[] {def1, }, null);
            RegisterClass("Range", typeof(Ruby.Builtins.Range), new System.Action<Ruby.Builtins.RubyModule>(LoadRange), Context.ObjectClass, new Ruby.Builtins.RubyModule[] {def1, }, null);
            RegisterClass("Regexp", typeof(Ruby.Builtins.Regexp), new System.Action<Ruby.Builtins.RubyModule>(LoadRegexp), Context.ObjectClass, new Ruby.Builtins.RubyModule[] {def1, }, null);
            RegisterClass("Float", typeof(System.Double), new System.Action<Ruby.Builtins.RubyModule>(LoadFloat), def9, Ruby.Builtins.RubyModule.EmptyArray, null);
            Ruby.Builtins.RubyClass def10 = RegisterClass("Integer", typeof(Ruby.Builtins.Integer), new System.Action<Ruby.Builtins.RubyModule>(LoadInteger), def9, Ruby.Builtins.RubyModule.EmptyArray, null);
            Context.FalseClass = RegisterClass("FalseClass", typeof(Ruby.Builtins.FalseClass), new System.Action<Ruby.Builtins.RubyModule>(LoadFalseClass), Context.ObjectClass, Ruby.Builtins.RubyModule.EmptyArray, null);
            Ruby.Builtins.RubyClass def3 = Context.ExceptionClass = RegisterClass("Exception", typeof(System.Exception), new System.Action<Ruby.Builtins.RubyModule>(LoadException), Context.ObjectClass, Ruby.Builtins.RubyModule.EmptyArray, new System.Delegate[] {
                new Microsoft.Scripting.Function<Ruby.Builtins.MutableString, System.Exception>(Ruby.Builtins.ExceptionOps.CreateException),
            });
            RegisterClass("Thread", typeof(System.Threading.Thread), new System.Action<Ruby.Builtins.RubyModule>(LoadThread), Context.ObjectClass, Ruby.Builtins.RubyModule.EmptyArray, null);
            RegisterClass("Method", typeof(Ruby.Builtins.Method), new System.Action<Ruby.Builtins.RubyModule>(LoadMethod), Context.ObjectClass, Ruby.Builtins.RubyModule.EmptyArray, null);
            RegisterClass("MutableString", typeof(Ruby.Builtins.MutableString), new System.Action<Ruby.Builtins.RubyModule>(LoadMutableString), Context.ObjectClass, Ruby.Builtins.RubyModule.EmptyArray, new System.Delegate[] {
                new Microsoft.Scripting.Function<Ruby.Builtins.MutableString>(Ruby.Builtins.MutableString.Create),
            });
            Context.TrueClass = RegisterClass("TrueClass", typeof(Ruby.Builtins.TrueClass), new System.Action<Ruby.Builtins.RubyModule>(LoadTrueClass), Context.ObjectClass, Ruby.Builtins.RubyModule.EmptyArray, null);
            Ruby.Builtins.RubyClass def11 = RegisterClass("Module", typeof(Ruby.Builtins.RubyModule), new System.Action<Ruby.Builtins.RubyModule>(LoadModule), Context.ObjectClass, Ruby.Builtins.RubyModule.EmptyArray, null);
            Context.NilClass = RegisterClass("NilClass", typeof(Microsoft.Scripting.None), new System.Action<Ruby.Builtins.RubyModule>(LoadNilClass), Context.ObjectClass, Ruby.Builtins.RubyModule.EmptyArray, null);
            RegisterClass("Proc", typeof(Ruby.Builtins.Proc), new System.Action<Ruby.Builtins.RubyModule>(LoadProc), Context.ObjectClass, Ruby.Builtins.RubyModule.EmptyArray, null);
            RegisterClass("Symbol", typeof(Microsoft.Scripting.SymbolId), new System.Action<Ruby.Builtins.RubyModule>(LoadSymbol), Context.ObjectClass, Ruby.Builtins.RubyModule.EmptyArray, null);
            RegisterClass("UnboundMethod", typeof(Ruby.Builtins.UnboundMethod), new System.Action<Ruby.Builtins.RubyModule>(LoadUnboundMethod), Context.ObjectClass, Ruby.Builtins.RubyModule.EmptyArray, null);
            RegisterClass("Bignum", typeof(Microsoft.Scripting.Math.BigInteger), new System.Action<Ruby.Builtins.RubyModule>(LoadBignum), def10, Ruby.Builtins.RubyModule.EmptyArray, null);
            RegisterClass("Fixnum", typeof(System.Int32), new System.Action<Ruby.Builtins.RubyModule>(LoadFixnum), def10, Ruby.Builtins.RubyModule.EmptyArray, null);
            Ruby.Builtins.RubyClass def4 = RegisterClass("ScriptError", typeof(Ruby.Builtins.ScriptError), new System.Action<Ruby.Builtins.RubyModule>(LoadScriptError), def3, Ruby.Builtins.RubyModule.EmptyArray, null);
            RegisterClass("NoMemoryError", typeof(Ruby.Builtins.NoMemoryError), new System.Action<Ruby.Builtins.RubyModule>(LoadNoMemoryError), def3, Ruby.Builtins.RubyModule.EmptyArray, null);
            RegisterClass("SystemStackError", typeof(Ruby.Builtins.SystemStackError), new System.Action<Ruby.Builtins.RubyModule>(LoadSystemStackError), def3, Ruby.Builtins.RubyModule.EmptyArray, null);
            Ruby.Builtins.RubyClass def7 = Context.StandardErrorClass = RegisterClass("StandardError", typeof(System.SystemException), new System.Action<Ruby.Builtins.RubyModule>(LoadStandardError), def3, Ruby.Builtins.RubyModule.EmptyArray, new System.Delegate[] {
                new Microsoft.Scripting.Function<Ruby.Builtins.MutableString, System.SystemException>(Ruby.Builtins.SystemExceptionOps.Factory),
            });
            Context.ClassClass = RegisterClass("Class", typeof(Ruby.Builtins.RubyClass), new System.Action<Ruby.Builtins.RubyModule>(LoadClass), def11, Ruby.Builtins.RubyModule.EmptyArray, null);
            RegisterClass("LoadError", typeof(Ruby.Builtins.LoadError), new System.Action<Ruby.Builtins.RubyModule>(LoadLoadError), def4, Ruby.Builtins.RubyModule.EmptyArray, null);
            RegisterClass("NotImplementedError", typeof(Ruby.Builtins.NotImplementedError), new System.Action<Ruby.Builtins.RubyModule>(LoadNotImplementedError), def4, Ruby.Builtins.RubyModule.EmptyArray, null);
            RegisterClass("SyntaxError", typeof(Ruby.Builtins.SyntaxError), new System.Action<Ruby.Builtins.RubyModule>(LoadSyntaxError), def4, Ruby.Builtins.RubyModule.EmptyArray, null);
            RegisterClass("LocalJumpError", typeof(Ruby.Builtins.LocalJumpError), new System.Action<Ruby.Builtins.RubyModule>(LoadLocalJumpError), def7, Ruby.Builtins.RubyModule.EmptyArray, null);
            RegisterClass("RegexpError", typeof(Ruby.Builtins.RegexpError), new System.Action<Ruby.Builtins.RubyModule>(LoadRegexpError), def7, Ruby.Builtins.RubyModule.EmptyArray, null);
            Context.RuntimeErrorClass = RegisterClass("RuntimeError", typeof(Ruby.Builtins.RuntimeError), new System.Action<Ruby.Builtins.RubyModule>(LoadRuntimeError), def7, Ruby.Builtins.RubyModule.EmptyArray, null);
            RegisterClass("ThreadError", typeof(Ruby.Builtins.ThreadError), new System.Action<Ruby.Builtins.RubyModule>(LoadThreadError), def7, Ruby.Builtins.RubyModule.EmptyArray, null);
            RegisterClass("ArgumentError", typeof(System.ArgumentException), new System.Action<Ruby.Builtins.RubyModule>(LoadArgumentError), def7, Ruby.Builtins.RubyModule.EmptyArray, new System.Delegate[] {
                new Microsoft.Scripting.Function<Ruby.Builtins.MutableString, System.ArgumentException>(Ruby.Builtins.ArgumentErrorOps.Factory),
            });
            Ruby.Builtins.RubyClass def5 = RegisterClass("IOError", typeof(System.IO.IOException), new System.Action<Ruby.Builtins.RubyModule>(LoadIOError), def7, Ruby.Builtins.RubyModule.EmptyArray, new System.Delegate[] {
                new Microsoft.Scripting.Function<Ruby.Builtins.MutableString, System.IO.IOException>(Ruby.Builtins.IOErrorOps.Factory),
            });
            RegisterClass("IndexError", typeof(System.IndexOutOfRangeException), new System.Action<Ruby.Builtins.RubyModule>(LoadIndexError), def7, Ruby.Builtins.RubyModule.EmptyArray, new System.Delegate[] {
                new Microsoft.Scripting.Function<Ruby.Builtins.MutableString, System.IndexOutOfRangeException>(Ruby.Builtins.IndexErrorOps.Factory),
            });
            Ruby.Builtins.RubyClass def6 = RegisterClass("RangeError", typeof(System.ArgumentOutOfRangeException), new System.Action<Ruby.Builtins.RubyModule>(LoadRangeError), def7, Ruby.Builtins.RubyModule.EmptyArray, new System.Delegate[] {
                new Microsoft.Scripting.Function<Ruby.Builtins.MutableString, System.ArgumentOutOfRangeException>(Ruby.Builtins.RangeErrorOps.Factory),
            });
            Ruby.Builtins.RubyClass def8 = RegisterClass("NameError", typeof(System.MemberAccessException), new System.Action<Ruby.Builtins.RubyModule>(LoadNameError), def7, Ruby.Builtins.RubyModule.EmptyArray, new System.Delegate[] {
                new Microsoft.Scripting.Function<Ruby.Builtins.MutableString, System.MemberAccessException>(Ruby.Builtins.NameErrorOps.Factory),
            });
            RegisterClass("SecurityError", typeof(System.Security.SecurityException), new System.Action<Ruby.Builtins.RubyModule>(LoadSecurityError), def7, Ruby.Builtins.RubyModule.EmptyArray, new System.Delegate[] {
                new Microsoft.Scripting.Function<Ruby.Builtins.MutableString, System.Security.SecurityException>(Ruby.Builtins.SecurityErrorOps.Factory),
            });
            Ruby.Builtins.RubyClass def2 = RegisterClass("SystemCallError", typeof(System.Runtime.InteropServices.ExternalException), new System.Action<Ruby.Builtins.RubyModule>(LoadSystemCallError), def7, Ruby.Builtins.RubyModule.EmptyArray, new System.Delegate[] {
                new Microsoft.Scripting.Function<Ruby.Builtins.MutableString, System.Runtime.InteropServices.ExternalException>(Ruby.Builtins.SystemCallErrorOps.Factory),
            });
            RegisterClass("TypeError", typeof(System.InvalidOperationException), new System.Action<Ruby.Builtins.RubyModule>(LoadTypeError), def7, Ruby.Builtins.RubyModule.EmptyArray, new System.Delegate[] {
                new Microsoft.Scripting.Function<Ruby.Builtins.MutableString, System.InvalidOperationException>(Ruby.Builtins.TypeErrorOps.Factory),
            });
            RegisterClass("ZeroDivisionError", typeof(System.DivideByZeroException), new System.Action<Ruby.Builtins.RubyModule>(LoadZeroDivisionError), def7, Ruby.Builtins.RubyModule.EmptyArray, new System.Delegate[] {
                new Microsoft.Scripting.Function<Ruby.Builtins.MutableString, System.DivideByZeroException>(Ruby.Builtins.ZeroDivisionErrorOps.Factory),
            });
            RegisterClass("EOFError", typeof(Ruby.Builtins.EOFError), new System.Action<Ruby.Builtins.RubyModule>(LoadEOFError), def5, Ruby.Builtins.RubyModule.EmptyArray, null);
            RegisterClass("FloatDomainError", typeof(Ruby.Builtins.FloatDomainError), new System.Action<Ruby.Builtins.RubyModule>(LoadFloatDomainError), def6, Ruby.Builtins.RubyModule.EmptyArray, null);
            RegisterClass("NoMethodError", typeof(System.MissingMethodException), new System.Action<Ruby.Builtins.RubyModule>(LoadNoMethodError), def8, Ruby.Builtins.RubyModule.EmptyArray, new System.Delegate[] {
                new Microsoft.Scripting.Function<Ruby.Builtins.MutableString, System.MissingMethodException>(Ruby.Builtins.NoMethodErrorOps.Factory),
            });
            RegisterClass("EDOM", typeof(Ruby.Builtins.Errno.DomainError), new System.Action<Ruby.Builtins.RubyModule>(LoadEDOM), def2, Ruby.Builtins.RubyModule.EmptyArray, null);
        }
        
        private void LoadArray(Ruby.Builtins.RubyModule/*!*/ module) {
            module.DefineInstanceMethod("initialize", Ruby.Runtime.RubyMethodVisibility.Public, new System.Delegate[] {
                new System.Action<System.Collections.Generic.List<System.Object>>(Ruby.Builtins.ArrayOps.Initialize),
                new Microsoft.Scripting.Action<System.Collections.Generic.List<System.Object>, System.Int32, System.Object>(Ruby.Builtins.ArrayOps.InitializeValue),
                new Microsoft.Scripting.Action<System.Collections.Generic.List<System.Object>, System.Int32>(Ruby.Builtins.ArrayOps.Initialize),
                new Microsoft.Scripting.Action<System.Collections.Generic.List<System.Object>, System.Object>(Ruby.Builtins.ArrayOps.Initialize),
                new Microsoft.Scripting.Action<System.Collections.Generic.List<System.Object>, System.Object, System.Object>(Ruby.Builtins.ArrayOps.Initialize),
                new Microsoft.Scripting.Action<System.Collections.Generic.List<System.Object>, System.Collections.Generic.List<System.Object>>(Ruby.Builtins.ArrayOps.Initialize),
                new Microsoft.Scripting.Action<Microsoft.Scripting.CodeContext, System.Collections.Generic.List<System.Object>, Ruby.Builtins.Proc, System.Int32>(Ruby.Builtins.ArrayOps.Initialize),
            });
            
            module.DefineInstanceMethod("*", Ruby.Runtime.RubyMethodVisibility.Public, new System.Delegate[] {
                new Microsoft.Scripting.Function<System.Collections.Generic.List<System.Object>, System.Int32, System.Collections.Generic.List<System.Object>>(Ruby.Builtins.ArrayOps.Repetition),
                new Microsoft.Scripting.Function<System.Collections.Generic.List<System.Object>, System.String, Ruby.Builtins.MutableString>(Ruby.Builtins.ArrayOps.Repetition),
                new Microsoft.Scripting.Function<System.Collections.Generic.List<System.Object>, Ruby.Builtins.MutableString, Ruby.Builtins.MutableString>(Ruby.Builtins.ArrayOps.Repetition),
                new Microsoft.Scripting.Function<System.Collections.Generic.List<System.Object>, System.Object, System.Object>(Ruby.Builtins.ArrayOps.Repetition),
            });
            
            module.DefineInstanceMethod("+", Ruby.Runtime.RubyMethodVisibility.Public, new System.Delegate[] {
                new Microsoft.Scripting.Function<System.Collections.Generic.List<System.Object>, System.Collections.Generic.List<System.Object>, System.Collections.Generic.List<System.Object>>(Ruby.Builtins.ArrayOps.Concatenate),
                new Microsoft.Scripting.Function<System.Collections.Generic.List<System.Object>, System.Object, System.Collections.Generic.List<System.Object>>(Ruby.Builtins.ArrayOps.Concatenate),
            });
            
            module.DefineInstanceMethod("<<", Ruby.Runtime.RubyMethodVisibility.Public, new System.Delegate[] {
                new Microsoft.Scripting.Function<System.Collections.Generic.List<System.Object>, System.Object, System.Collections.Generic.List<System.Object>>(Ruby.Builtins.ArrayOps.Append),
            });
            
            module.DefineInstanceMethod("<=>", Ruby.Runtime.RubyMethodVisibility.Public, new System.Delegate[] {
                new Microsoft.Scripting.Function<System.Collections.Generic.List<System.Object>, System.Collections.Generic.List<System.Object>, System.Int32>(Ruby.Builtins.ArrayOps.Compare),
                new Microsoft.Scripting.Function<System.Collections.Generic.List<System.Object>, System.Object, System.Int32>(Ruby.Builtins.ArrayOps.Compare),
            });
            
            module.DefineInstanceMethod("==", Ruby.Runtime.RubyMethodVisibility.Public, new System.Delegate[] {
                new Microsoft.Scripting.Function<System.Collections.Generic.List<System.Object>, System.Object, System.Boolean>(Ruby.Builtins.ArrayOps.Equals),
                new Microsoft.Scripting.Function<System.Collections.Generic.List<System.Object>, System.Collections.Generic.List<System.Object>, System.Boolean>(Ruby.Builtins.ArrayOps.Equals),
            });
            
            module.DefineInstanceMethod("[]", Ruby.Runtime.RubyMethodVisibility.Public, new System.Delegate[] {
                new Microsoft.Scripting.Function<System.Collections.Generic.List<System.Object>, System.Int32, System.Object>(Ruby.Builtins.ArrayOps.GetElement),
                new Microsoft.Scripting.Function<System.Collections.Generic.List<System.Object>, System.Object, System.Object>(Ruby.Builtins.ArrayOps.GetElement),
                new Microsoft.Scripting.Function<System.Collections.Generic.List<System.Object>, System.Int32, System.Int32, System.Collections.Generic.List<System.Object>>(Ruby.Builtins.ArrayOps.GetElements),
                new Microsoft.Scripting.Function<System.Collections.Generic.List<System.Object>, System.Int32, System.Object, System.Collections.Generic.List<System.Object>>(Ruby.Builtins.ArrayOps.GetElement),
                new Microsoft.Scripting.Function<System.Collections.Generic.List<System.Object>, System.Object, System.Int32, System.Collections.Generic.List<System.Object>>(Ruby.Builtins.ArrayOps.GetElement),
                new Microsoft.Scripting.Function<System.Collections.Generic.List<System.Object>, System.Object, System.Object, System.Collections.Generic.List<System.Object>>(Ruby.Builtins.ArrayOps.GetElement),
                new Microsoft.Scripting.Function<System.Collections.Generic.List<System.Object>, Ruby.Builtins.Range, System.Collections.Generic.List<System.Object>>(Ruby.Builtins.ArrayOps.GetElement),
            });
            
            module.DefineInstanceMethod("slice", Ruby.Runtime.RubyMethodVisibility.Public, new System.Delegate[] {
                new Microsoft.Scripting.Function<System.Collections.Generic.List<System.Object>, System.Int32, System.Object>(Ruby.Builtins.ArrayOps.GetElement),
                new Microsoft.Scripting.Function<System.Collections.Generic.List<System.Object>, System.Object, System.Object>(Ruby.Builtins.ArrayOps.GetElement),
                new Microsoft.Scripting.Function<System.Collections.Generic.List<System.Object>, System.Int32, System.Int32, System.Collections.Generic.List<System.Object>>(Ruby.Builtins.ArrayOps.GetElements),
                new Microsoft.Scripting.Function<System.Collections.Generic.List<System.Object>, System.Int32, System.Object, System.Collections.Generic.List<System.Object>>(Ruby.Builtins.ArrayOps.GetElement),
                new Microsoft.Scripting.Function<System.Collections.Generic.List<System.Object>, System.Object, System.Int32, System.Collections.Generic.List<System.Object>>(Ruby.Builtins.ArrayOps.GetElement),
                new Microsoft.Scripting.Function<System.Collections.Generic.List<System.Object>, System.Object, System.Object, System.Collections.Generic.List<System.Object>>(Ruby.Builtins.ArrayOps.GetElement),
                new Microsoft.Scripting.Function<System.Collections.Generic.List<System.Object>, Ruby.Builtins.Range, System.Collections.Generic.List<System.Object>>(Ruby.Builtins.ArrayOps.GetElement),
            });
            
            module.DefineInstanceMethod("[]=", Ruby.Runtime.RubyMethodVisibility.Public, new System.Delegate[] {
                new Microsoft.Scripting.Function<System.Collections.Generic.List<System.Object>, System.Int32, System.Object, System.Object>(Ruby.Builtins.ArrayOps.SetElement),
                new Microsoft.Scripting.Function<System.Collections.Generic.List<System.Object>, System.Object, System.Object, System.Object>(Ruby.Builtins.ArrayOps.SetElement),
                new Microsoft.Scripting.Function<System.Collections.Generic.List<System.Object>, System.Int32, System.Int32, System.Object, System.Object>(Ruby.Builtins.ArrayOps.SetElement),
                new Microsoft.Scripting.Function<System.Collections.Generic.List<System.Object>, System.Int32, System.Object, System.Object, System.Object>(Ruby.Builtins.ArrayOps.SetElement),
                new Microsoft.Scripting.Function<System.Collections.Generic.List<System.Object>, System.Object, System.Int32, System.Object, System.Object>(Ruby.Builtins.ArrayOps.SetElement),
                new Microsoft.Scripting.Function<System.Collections.Generic.List<System.Object>, System.Object, System.Object, System.Object, System.Object>(Ruby.Builtins.ArrayOps.SetElement),
                new Microsoft.Scripting.Function<System.Collections.Generic.List<System.Object>, Ruby.Builtins.Range, System.Object, System.Object>(Ruby.Builtins.ArrayOps.SetElement),
            });
            
            module.DefineInstanceMethod("|", Ruby.Runtime.RubyMethodVisibility.Public, new System.Delegate[] {
                new Microsoft.Scripting.Function<System.Collections.Generic.List<System.Object>, System.Collections.Generic.List<System.Object>, System.Collections.Generic.List<System.Object>>(Ruby.Builtins.ArrayOps.Union),
            });
            
            module.DefineInstanceMethod("assoc", Ruby.Runtime.RubyMethodVisibility.Public, new System.Delegate[] {
                new Microsoft.Scripting.Function<System.Collections.Generic.List<System.Object>, System.Object, System.Collections.Generic.List<System.Object>>(Ruby.Builtins.ArrayOps.GetContainerOfFirstItem),
            });
            
            module.DefineInstanceMethod("at", Ruby.Runtime.RubyMethodVisibility.Public, new System.Delegate[] {
                new Microsoft.Scripting.Function<System.Collections.Generic.List<System.Object>, System.Int32, System.Object>(Ruby.Builtins.ArrayOps.At),
                new Microsoft.Scripting.Function<System.Collections.Generic.List<System.Object>, System.Object, System.Object>(Ruby.Builtins.ArrayOps.At),
            });
            
            module.DefineInstanceMethod("clear", Ruby.Runtime.RubyMethodVisibility.Public, new System.Delegate[] {
                new Microsoft.Scripting.Function<System.Collections.Generic.List<System.Object>, System.Collections.Generic.List<System.Object>>(Ruby.Builtins.ArrayOps.Clear),
            });
            
            module.DefineInstanceMethod("map!", Ruby.Runtime.RubyMethodVisibility.Public, new System.Delegate[] {
                new Microsoft.Scripting.Function<Microsoft.Scripting.CodeContext, System.Collections.Generic.List<System.Object>, Ruby.Builtins.Proc, System.Object>(Ruby.Builtins.ArrayOps.CollectInPlace),
            });
            
            module.DefineInstanceMethod("collect!", Ruby.Runtime.RubyMethodVisibility.Public, new System.Delegate[] {
                new Microsoft.Scripting.Function<Microsoft.Scripting.CodeContext, System.Collections.Generic.List<System.Object>, Ruby.Builtins.Proc, System.Object>(Ruby.Builtins.ArrayOps.CollectInPlace),
            });
            
            module.DefineInstanceMethod("compact", Ruby.Runtime.RubyMethodVisibility.Public, new System.Delegate[] {
                new Microsoft.Scripting.Function<System.Collections.Generic.List<System.Object>, System.Collections.Generic.List<System.Object>>(Ruby.Builtins.ArrayOps.Compact),
            });
            
            module.DefineInstanceMethod("compact!", Ruby.Runtime.RubyMethodVisibility.Public, new System.Delegate[] {
                new Microsoft.Scripting.Function<System.Collections.Generic.List<System.Object>, System.Collections.Generic.List<System.Object>>(Ruby.Builtins.ArrayOps.CompactInPlace),
            });
            
            module.DefineInstanceMethod("concat", Ruby.Runtime.RubyMethodVisibility.Public, new System.Delegate[] {
                new Microsoft.Scripting.Function<System.Collections.Generic.List<System.Object>, System.Collections.Generic.List<System.Object>, System.Collections.Generic.List<System.Object>>(Ruby.Builtins.ArrayOps.Concat),
                new Microsoft.Scripting.Function<System.Collections.Generic.List<System.Object>, System.Object, System.Collections.Generic.List<System.Object>>(Ruby.Builtins.ArrayOps.Concat),
            });
            
            module.DefineInstanceMethod("delete", Ruby.Runtime.RubyMethodVisibility.Public, new System.Delegate[] {
                new Microsoft.Scripting.Function<System.Collections.Generic.List<System.Object>, System.Object, System.Object>(Ruby.Builtins.ArrayOps.Delete),
                new Microsoft.Scripting.Function<Microsoft.Scripting.CodeContext, System.Collections.Generic.List<System.Object>, Ruby.Builtins.Proc, System.Object, System.Object>(Ruby.Builtins.ArrayOps.Delete),
            });
            
            module.DefineInstanceMethod("delete_at", Ruby.Runtime.RubyMethodVisibility.Public, new System.Delegate[] {
                new Microsoft.Scripting.Function<System.Collections.Generic.List<System.Object>, System.Object, System.Object>(Ruby.Builtins.ArrayOps.DeleteAt),
            });
            
            module.DefineInstanceMethod("each", Ruby.Runtime.RubyMethodVisibility.Public, new System.Delegate[] {
                new Microsoft.Scripting.Function<Microsoft.Scripting.CodeContext, System.Collections.Generic.List<System.Object>, Ruby.Builtins.Proc, System.Collections.Generic.List<System.Object>>(Ruby.Builtins.ArrayOps.Each),
            });
            
            module.DefineInstanceMethod("each_index", Ruby.Runtime.RubyMethodVisibility.Public, new System.Delegate[] {
                new Microsoft.Scripting.Function<Microsoft.Scripting.CodeContext, System.Collections.Generic.List<System.Object>, Ruby.Builtins.Proc, System.Object>(Ruby.Builtins.ArrayOps.EachIndex),
            });
            
            module.DefineInstanceMethod("empty?", Ruby.Runtime.RubyMethodVisibility.Public, new System.Delegate[] {
                new Microsoft.Scripting.Function<System.Collections.Generic.List<System.Object>, System.Boolean>(Ruby.Builtins.ArrayOps.Empty),
            });
            
            module.DefineInstanceMethod("fetch", Ruby.Runtime.RubyMethodVisibility.Public, new System.Delegate[] {
                new Microsoft.Scripting.Function<System.Collections.Generic.List<System.Object>, System.Int32, System.Object>(Ruby.Builtins.ArrayOps.Fetch),
                new Microsoft.Scripting.Function<System.Collections.Generic.List<System.Object>, System.Object, System.Object>(Ruby.Builtins.ArrayOps.Fetch),
                new Microsoft.Scripting.Function<System.Collections.Generic.List<System.Object>, System.Int32, System.Object, System.Object>(Ruby.Builtins.ArrayOps.Fetch),
            });
            
            module.DefineInstanceMethod("first", Ruby.Runtime.RubyMethodVisibility.Public, new System.Delegate[] {
                new Microsoft.Scripting.Function<System.Collections.Generic.List<System.Object>, System.Object>(Ruby.Builtins.ArrayOps.First),
                new Microsoft.Scripting.Function<System.Collections.Generic.List<System.Object>, System.Int32, System.Collections.Generic.List<System.Object>>(Ruby.Builtins.ArrayOps.First),
                new Microsoft.Scripting.Function<System.Collections.Generic.List<System.Object>, System.Object, System.Object>(Ruby.Builtins.ArrayOps.First),
            });
            
            module.DefineInstanceMethod("flatten", Ruby.Runtime.RubyMethodVisibility.Public, new System.Delegate[] {
                new Microsoft.Scripting.Function<System.Collections.Generic.List<System.Object>, System.Collections.Generic.List<System.Object>>(Ruby.Builtins.ArrayOps.Flatten),
            });
            
            module.DefineInstanceMethod("flatten!", Ruby.Runtime.RubyMethodVisibility.Public, new System.Delegate[] {
                new Microsoft.Scripting.Function<System.Collections.Generic.List<System.Object>, System.Collections.Generic.List<System.Object>>(Ruby.Builtins.ArrayOps.FlattenInPlace),
            });
            
            module.DefineInstanceMethod("include?", Ruby.Runtime.RubyMethodVisibility.Public, new System.Delegate[] {
                new Microsoft.Scripting.Function<System.Collections.Generic.List<System.Object>, System.Object, System.Boolean>(Ruby.Builtins.ArrayOps.Include),
            });
            
            module.DefineInstanceMethod("index", Ruby.Runtime.RubyMethodVisibility.Public, new System.Delegate[] {
                new Microsoft.Scripting.Function<System.Collections.Generic.List<System.Object>, System.Object, System.Object>(Ruby.Builtins.ArrayOps.Index),
            });
            
            module.DefineInstanceMethod("indexes", Ruby.Runtime.RubyMethodVisibility.Public, new System.Delegate[] {
                new Microsoft.Scripting.Function<System.Collections.Generic.List<System.Object>, System.Object[], System.Object>(Ruby.Builtins.ArrayOps.Indexes),
            });
            
            module.DefineInstanceMethod("indices", Ruby.Runtime.RubyMethodVisibility.Public, new System.Delegate[] {
                new Microsoft.Scripting.Function<System.Collections.Generic.List<System.Object>, System.Object[], System.Object>(Ruby.Builtins.ArrayOps.Indices),
            });
            
            module.DefineInstanceMethod("insert", Ruby.Runtime.RubyMethodVisibility.Public, new System.Delegate[] {
                new Microsoft.Scripting.Function<System.Collections.Generic.List<System.Object>, System.Int32, System.Object[], System.Collections.Generic.List<System.Object>>(Ruby.Builtins.ArrayOps.Insert),
            });
            
            module.DefineInstanceMethod("inspect", Ruby.Runtime.RubyMethodVisibility.Public, new System.Delegate[] {
                new Microsoft.Scripting.Function<System.Collections.Generic.List<System.Object>, Ruby.Builtins.MutableString>(Ruby.Builtins.ArrayOps.Inspect),
            });
            
            module.DefineInstanceMethod("to_s", Ruby.Runtime.RubyMethodVisibility.Public, new System.Delegate[] {
                new Microsoft.Scripting.Function<Microsoft.Scripting.CodeContext, System.Collections.Generic.List<System.Object>, Ruby.Builtins.MutableString>(Ruby.Builtins.ArrayOps.Join),
            });
            
            module.DefineInstanceMethod("join", Ruby.Runtime.RubyMethodVisibility.Public, new System.Delegate[] {
                new Microsoft.Scripting.Function<Microsoft.Scripting.CodeContext, System.Collections.Generic.List<System.Object>, Ruby.Builtins.MutableString>(Ruby.Builtins.ArrayOps.Join),
                new Microsoft.Scripting.Function<System.Collections.Generic.List<System.Object>, System.String, Ruby.Builtins.MutableString>(Ruby.Builtins.ArrayOps.Join),
                new Microsoft.Scripting.Function<System.Collections.Generic.List<System.Object>, Ruby.Builtins.MutableString, Ruby.Builtins.MutableString>(Ruby.Builtins.ArrayOps.Join),
            });
            
            module.DefineInstanceMethod("last", Ruby.Runtime.RubyMethodVisibility.Public, new System.Delegate[] {
                new Microsoft.Scripting.Function<System.Collections.Generic.List<System.Object>, System.Object>(Ruby.Builtins.ArrayOps.Last),
                new Microsoft.Scripting.Function<System.Collections.Generic.List<System.Object>, System.Int32, System.Object>(Ruby.Builtins.ArrayOps.Last),
                new Microsoft.Scripting.Function<System.Collections.Generic.List<System.Object>, System.Object, System.Object>(Ruby.Builtins.ArrayOps.Last),
            });
            
            module.DefineInstanceMethod("length", Ruby.Runtime.RubyMethodVisibility.Public, new System.Delegate[] {
                new Microsoft.Scripting.Function<System.Collections.Generic.List<System.Object>, System.Int32>(Ruby.Builtins.ArrayOps.Length),
            });
            
            module.DefineInstanceMethod("size", Ruby.Runtime.RubyMethodVisibility.Public, new System.Delegate[] {
                new Microsoft.Scripting.Function<System.Collections.Generic.List<System.Object>, System.Int32>(Ruby.Builtins.ArrayOps.Length),
            });
            
            module.DefineInstanceMethod("nitems", Ruby.Runtime.RubyMethodVisibility.Public, new System.Delegate[] {
                new Microsoft.Scripting.Function<System.Collections.Generic.List<System.Object>, System.Int32>(Ruby.Builtins.ArrayOps.NumberOfNonNilItems),
            });
            
            module.DefineInstanceMethod("pop", Ruby.Runtime.RubyMethodVisibility.Public, new System.Delegate[] {
                new Microsoft.Scripting.Function<System.Collections.Generic.List<System.Object>, System.Object>(Ruby.Builtins.ArrayOps.Pop),
            });
            
            module.DefineInstanceMethod("push", Ruby.Runtime.RubyMethodVisibility.Public, new System.Delegate[] {
                new Microsoft.Scripting.Function<System.Collections.Generic.List<System.Object>, System.Object[], System.Object>(Ruby.Builtins.ArrayOps.Push),
            });
            
            module.DefineInstanceMethod("reverse", Ruby.Runtime.RubyMethodVisibility.Public, new System.Delegate[] {
                new Microsoft.Scripting.Function<System.Collections.Generic.List<System.Object>, System.Collections.Generic.List<System.Object>>(Ruby.Builtins.ArrayOps.Reverse),
            });
            
            module.DefineInstanceMethod("reverse!", Ruby.Runtime.RubyMethodVisibility.Public, new System.Delegate[] {
                new Microsoft.Scripting.Function<System.Collections.Generic.List<System.Object>, System.Collections.Generic.List<System.Object>>(Ruby.Builtins.ArrayOps.InPlaceReverse),
            });
            
            module.DefineInstanceMethod("rassoc", Ruby.Runtime.RubyMethodVisibility.Public, new System.Delegate[] {
                new Microsoft.Scripting.Function<System.Collections.Generic.List<System.Object>, System.Object, System.Collections.Generic.List<System.Object>>(Ruby.Builtins.ArrayOps.GetContainerOfSecondItem),
            });
            
            module.DefineInstanceMethod("replace", Ruby.Runtime.RubyMethodVisibility.Public, new System.Delegate[] {
                new Microsoft.Scripting.Function<System.Collections.Generic.List<System.Object>, System.Collections.Generic.List<System.Object>, System.Collections.Generic.List<System.Object>>(Ruby.Builtins.ArrayOps.Replace),
                new Microsoft.Scripting.Function<System.Collections.Generic.List<System.Object>, System.Object, System.Collections.Generic.List<System.Object>>(Ruby.Builtins.ArrayOps.Replace),
            });
            
            module.DefineInstanceMethod("rindex", Ruby.Runtime.RubyMethodVisibility.Public, new System.Delegate[] {
                new Microsoft.Scripting.Function<System.Collections.Generic.List<System.Object>, System.Object, System.Object>(Ruby.Builtins.ArrayOps.ReverseIndex),
            });
            
            module.DefineInstanceMethod("shift", Ruby.Runtime.RubyMethodVisibility.Public, new System.Delegate[] {
                new Microsoft.Scripting.Function<System.Collections.Generic.List<System.Object>, System.Object>(Ruby.Builtins.ArrayOps.Shift),
            });
            
            module.DefineInstanceMethod("slice!", Ruby.Runtime.RubyMethodVisibility.Public, new System.Delegate[] {
                new Microsoft.Scripting.Function<System.Collections.Generic.List<System.Object>, System.Int32, System.Object>(Ruby.Builtins.ArrayOps.SliceInPlace),
                new Microsoft.Scripting.Function<System.Collections.Generic.List<System.Object>, Ruby.Builtins.Range, System.Object>(Ruby.Builtins.ArrayOps.SliceInPlace),
                new Microsoft.Scripting.Function<System.Collections.Generic.List<System.Object>, System.Object, System.Object>(Ruby.Builtins.ArrayOps.SliceInPlace),
                new Microsoft.Scripting.Function<System.Collections.Generic.List<System.Object>, System.Int32, System.Int32, System.Collections.Generic.List<System.Object>>(Ruby.Builtins.ArrayOps.SliceInPlace),
            });
            
            module.DefineInstanceMethod("sort", Ruby.Runtime.RubyMethodVisibility.Public, new System.Delegate[] {
                new Microsoft.Scripting.Function<System.Collections.Generic.List<System.Object>, System.Collections.Generic.List<System.Object>>(Ruby.Builtins.ArrayOps.Sort),
            });
            
            module.DefineInstanceMethod("sort!", Ruby.Runtime.RubyMethodVisibility.Public, new System.Delegate[] {
                new Microsoft.Scripting.Function<System.Collections.Generic.List<System.Object>, System.Collections.Generic.List<System.Object>>(Ruby.Builtins.ArrayOps.SortInPlace),
            });
            
            module.DefineInstanceMethod("to_ary", Ruby.Runtime.RubyMethodVisibility.Public, new System.Delegate[] {
                new Microsoft.Scripting.Function<System.Collections.Generic.List<System.Object>, System.Collections.Generic.List<System.Object>>(Ruby.Builtins.ArrayOps.ToArray),
            });
            
            module.DefineInstanceMethod("to_a", Ruby.Runtime.RubyMethodVisibility.Public, new System.Delegate[] {
                new Microsoft.Scripting.Function<System.Collections.Generic.List<System.Object>, System.Collections.Generic.List<System.Object>>(Ruby.Builtins.ArrayOps.ToArray),
            });
            
            module.DefineInstanceMethod("uniq", Ruby.Runtime.RubyMethodVisibility.Public, new System.Delegate[] {
                new Microsoft.Scripting.Function<System.Collections.Generic.List<System.Object>, System.Collections.Generic.List<System.Object>>(Ruby.Builtins.ArrayOps.Unique),
            });
            
            module.DefineInstanceMethod("uniq!", Ruby.Runtime.RubyMethodVisibility.Public, new System.Delegate[] {
                new Microsoft.Scripting.Function<System.Collections.Generic.List<System.Object>, System.Collections.Generic.List<System.Object>>(Ruby.Builtins.ArrayOps.UniqueSelf),
            });
            
            module.DefineInstanceMethod("unshift", Ruby.Runtime.RubyMethodVisibility.Public, new System.Delegate[] {
                new Microsoft.Scripting.Function<System.Collections.Generic.List<System.Object>, System.Object[], System.Collections.Generic.List<System.Object>>(Ruby.Builtins.ArrayOps.UnShift),
            });
            
            module.DefineInstanceMethod("values_at", Ruby.Runtime.RubyMethodVisibility.Public, new System.Delegate[] {
                new Microsoft.Scripting.Function<System.Collections.Generic.List<System.Object>, System.Object[], System.Collections.Generic.List<System.Object>>(Ruby.Builtins.ArrayOps.ValuesAt),
            });
            
            module.DefineClassMethod("[]", Ruby.Runtime.RubyMethodVisibility.Public, new System.Delegate[] {
                new Microsoft.Scripting.Function<System.Object[], System.Collections.Generic.List<System.Object>>(Ruby.Builtins.ArrayOps.MakeArray),
            });
            
        }
        
        private void LoadErrno(Ruby.Builtins.RubyModule/*!*/ module) {
        }
        
        private void LoadEDOM(Ruby.Builtins.RubyModule/*!*/ module) {
        }
        
        private void LoadFalseClass(Ruby.Builtins.RubyModule/*!*/ module) {
            module.DefineInstanceMethod("to_s", Ruby.Runtime.RubyMethodVisibility.Public, new System.Delegate[] {
                new Microsoft.Scripting.Function<System.Boolean, Ruby.Builtins.MutableString>(Ruby.Builtins.FalseClass.ToString),
            });
            
            module.DefineInstanceMethod("inspect", Ruby.Runtime.RubyMethodVisibility.Public, new System.Delegate[] {
                new Microsoft.Scripting.Function<System.Boolean, Ruby.Builtins.MutableString>(Ruby.Builtins.FalseClass.ToString),
            });
            
            module.DefineInstanceMethod("&", Ruby.Runtime.RubyMethodVisibility.Public, new System.Delegate[] {
                new Microsoft.Scripting.Function<System.Boolean, System.Object, System.Boolean>(Ruby.Builtins.FalseClass.And),
            });
            
            module.DefineInstanceMethod("^", Ruby.Runtime.RubyMethodVisibility.Public, new System.Delegate[] {
                new Microsoft.Scripting.Function<System.Boolean, System.Object, System.Boolean>(Ruby.Builtins.FalseClass.Xor),
                new Microsoft.Scripting.Function<System.Boolean, System.Boolean, System.Boolean>(Ruby.Builtins.FalseClass.Xor),
            });
            
            module.DefineInstanceMethod("|", Ruby.Runtime.RubyMethodVisibility.Public, new System.Delegate[] {
                new Microsoft.Scripting.Function<System.Boolean, System.Object, System.Boolean>(Ruby.Builtins.FalseClass.Or),
                new Microsoft.Scripting.Function<System.Boolean, System.Boolean, System.Boolean>(Ruby.Builtins.FalseClass.Or),
            });
            
        }
        
        private void LoadException(Ruby.Builtins.RubyModule/*!*/ module) {
            module.DefineInstanceMethod("initialize", Ruby.Runtime.RubyMethodVisibility.Private, new System.Delegate[] {
                new Microsoft.Scripting.Function<System.Exception, System.Exception>(Ruby.Builtins.ExceptionOps.Initialize),
                new Microsoft.Scripting.Function<System.Exception, Ruby.Builtins.MutableString, System.Exception>(Ruby.Builtins.ExceptionOps.Initialize),
            });
            
            module.DefineInstanceMethod("backtrace", Ruby.Runtime.RubyMethodVisibility.Public, new System.Delegate[] {
                new Microsoft.Scripting.Function<System.Exception, System.Collections.Generic.List<System.Object>>(Ruby.Builtins.ExceptionOps.GetBacktrace),
            });
            
            module.DefineInstanceMethod("set_backtrace", Ruby.Runtime.RubyMethodVisibility.Public, new System.Delegate[] {
                new Microsoft.Scripting.Function<System.Exception, Ruby.Builtins.MutableString, System.Collections.Generic.List<System.Object>>(Ruby.Builtins.ExceptionOps.SetBacktrace),
                new Microsoft.Scripting.Function<System.Exception, System.Collections.Generic.List<System.Object>, System.Collections.Generic.List<System.Object>>(Ruby.Builtins.ExceptionOps.SetBacktrace),
            });
            
            module.DefineInstanceMethod("exception", Ruby.Runtime.RubyMethodVisibility.Public, new System.Delegate[] {
                new Microsoft.Scripting.Function<System.Exception, System.Exception>(Ruby.Builtins.ExceptionOps.GetException),
                new Microsoft.Scripting.Function<Microsoft.Scripting.CodeContext, System.Exception, Ruby.Builtins.MutableString, System.Exception>(Ruby.Builtins.ExceptionOps.GetException),
            });
            
            module.DefineInstanceMethod("to_s", Ruby.Runtime.RubyMethodVisibility.Public, new System.Delegate[] {
                new Microsoft.Scripting.Function<System.Exception, Ruby.Builtins.MutableString>(Ruby.Builtins.ExceptionOps.GetMessage),
            });
            
            module.DefineInstanceMethod("message", Ruby.Runtime.RubyMethodVisibility.Public, new System.Delegate[] {
                new Microsoft.Scripting.Function<System.Exception, Ruby.Builtins.MutableString>(Ruby.Builtins.ExceptionOps.GetMessage),
            });
            
            module.DefineClassMethod("exception", Ruby.Runtime.RubyMethodVisibility.Public, new System.Delegate[] {
                new Microsoft.Scripting.Function<Microsoft.Scripting.CodeContext, Ruby.Builtins.RubyClass, System.Exception>(Ruby.Builtins.ExceptionOps.CreateException),
                new Microsoft.Scripting.Function<Microsoft.Scripting.CodeContext, Ruby.Builtins.RubyClass, Ruby.Builtins.MutableString, System.Exception>(Ruby.Builtins.ExceptionOps.CreateException),
            });
            
        }
        
        private void LoadScriptError(Ruby.Builtins.RubyModule/*!*/ module) {
        }
        
        private void LoadLoadError(Ruby.Builtins.RubyModule/*!*/ module) {
        }
        
        private void LoadNotImplementedError(Ruby.Builtins.RubyModule/*!*/ module) {
        }
        
        private void LoadSyntaxError(Ruby.Builtins.RubyModule/*!*/ module) {
        }
        
        private void LoadNoMemoryError(Ruby.Builtins.RubyModule/*!*/ module) {
        }
        
        private void LoadSystemStackError(Ruby.Builtins.RubyModule/*!*/ module) {
        }
        
        private void LoadEOFError(Ruby.Builtins.RubyModule/*!*/ module) {
        }
        
        private void LoadFloatDomainError(Ruby.Builtins.RubyModule/*!*/ module) {
        }
        
        private void LoadLocalJumpError(Ruby.Builtins.RubyModule/*!*/ module) {
        }
        
        private void LoadRegexpError(Ruby.Builtins.RubyModule/*!*/ module) {
        }
        
        private void LoadRuntimeError(Ruby.Builtins.RubyModule/*!*/ module) {
        }
        
        private void LoadThreadError(Ruby.Builtins.RubyModule/*!*/ module) {
        }
        
        private void LoadStandardError(Ruby.Builtins.RubyModule/*!*/ module) {
        }
        
        private void LoadArgumentError(Ruby.Builtins.RubyModule/*!*/ module) {
        }
        
        private void LoadIOError(Ruby.Builtins.RubyModule/*!*/ module) {
        }
        
        private void LoadIndexError(Ruby.Builtins.RubyModule/*!*/ module) {
        }
        
        private void LoadRangeError(Ruby.Builtins.RubyModule/*!*/ module) {
        }
        
        private void LoadNameError(Ruby.Builtins.RubyModule/*!*/ module) {
        }
        
        private void LoadNoMethodError(Ruby.Builtins.RubyModule/*!*/ module) {
        }
        
        private void LoadSecurityError(Ruby.Builtins.RubyModule/*!*/ module) {
        }
        
        private void LoadSystemCallError(Ruby.Builtins.RubyModule/*!*/ module) {
        }
        
        private void LoadTypeError(Ruby.Builtins.RubyModule/*!*/ module) {
        }
        
        private void LoadZeroDivisionError(Ruby.Builtins.RubyModule/*!*/ module) {
        }
        
        private void LoadFloat(Ruby.Builtins.RubyModule/*!*/ module) {
            module.DefineInstanceMethod("to_i", Ruby.Runtime.RubyMethodVisibility.Public, new System.Delegate[] {
                new Microsoft.Scripting.Function<System.Double, System.Int32>(Ruby.Builtins.FloatOps.ToInteger),
            });
            
            module.DefineInstanceMethod("to_s", Ruby.Runtime.RubyMethodVisibility.Public, new System.Delegate[] {
                new Microsoft.Scripting.Function<System.Double, Ruby.Builtins.MutableString>(Ruby.Builtins.FloatOps.ToString),
            });
            
            module.DefineInstanceMethod("inspect", Ruby.Runtime.RubyMethodVisibility.Public, new System.Delegate[] {
                new Microsoft.Scripting.Function<System.Double, Ruby.Builtins.MutableString>(Ruby.Builtins.FloatOps.ToString),
            });
            
        }
        
        private void LoadHash(Ruby.Builtins.RubyModule/*!*/ module) {
            module.DefineInstanceMethod("inspect", Ruby.Runtime.RubyMethodVisibility.Public, new System.Delegate[] {
                new Microsoft.Scripting.Function<System.Collections.Generic.Dictionary<System.Object, System.Object>, Ruby.Builtins.MutableString>(Ruby.Builtins.HashOps.Inspect),
            });
            
            module.DefineInstanceMethod("to_s", Ruby.Runtime.RubyMethodVisibility.Public, new System.Delegate[] {
                new Microsoft.Scripting.Function<System.Collections.Generic.Dictionary<System.Object, System.Object>, Ruby.Builtins.MutableString>(Ruby.Builtins.HashOps.ToS),
            });
            
            module.DefineClassMethod("[]", Ruby.Runtime.RubyMethodVisibility.Public, new System.Delegate[] {
                new Microsoft.Scripting.Function<System.Object[], System.Collections.Generic.Dictionary<System.Object, System.Object>>(Ruby.Builtins.HashOps.CreateHash),
            });
            
        }
        
        private void LoadThread(Ruby.Builtins.RubyModule/*!*/ module) {
            module.DefineInstanceMethod("join", Ruby.Runtime.RubyMethodVisibility.Public, new System.Delegate[] {
                new Microsoft.Scripting.Function<System.Threading.Thread, System.Threading.Thread>(Ruby.Builtins.ThreadOps.Join),
            });
            
            module.DefineClassMethod("new", Ruby.Runtime.RubyMethodVisibility.Public, new System.Delegate[] {
                new Microsoft.Scripting.Function<Microsoft.Scripting.CodeContext, System.Object, Ruby.Builtins.Proc, System.Object[], System.Threading.Thread>(Ruby.Builtins.ThreadOps.CreateThread),
            });
            
        }
        
        private void LoadMath(Ruby.Builtins.RubyModule/*!*/ module) {
            module.DefineInstanceMethod("acos", Ruby.Runtime.RubyMethodVisibility.Private, new System.Delegate[] {
                new Microsoft.Scripting.Function<System.Object, System.Double, System.Double>(Ruby.Builtins.Math.Acos),
            });
            
            module.DefineInstanceMethod("asin", Ruby.Runtime.RubyMethodVisibility.Private, new System.Delegate[] {
                new Microsoft.Scripting.Function<System.Object, System.Double, System.Double>(Ruby.Builtins.Math.Asin),
            });
            
            module.DefineInstanceMethod("atan", Ruby.Runtime.RubyMethodVisibility.Private, new System.Delegate[] {
                new Microsoft.Scripting.Function<System.Object, System.Double, System.Double>(Ruby.Builtins.Math.Atan),
            });
            
            module.DefineInstanceMethod("atan2", Ruby.Runtime.RubyMethodVisibility.Private, new System.Delegate[] {
                new Microsoft.Scripting.Function<System.Object, System.Double, System.Double, System.Double>(Ruby.Builtins.Math.Atan2),
            });
            
            module.DefineInstanceMethod("cos", Ruby.Runtime.RubyMethodVisibility.Private, new System.Delegate[] {
                new Microsoft.Scripting.Function<System.Object, System.Double, System.Double>(Ruby.Builtins.Math.Cos),
            });
            
            module.DefineInstanceMethod("cosh", Ruby.Runtime.RubyMethodVisibility.Private, new System.Delegate[] {
                new Microsoft.Scripting.Function<System.Object, System.Double, System.Double>(Ruby.Builtins.Math.Cosh),
            });
            
            module.DefineInstanceMethod("exp", Ruby.Runtime.RubyMethodVisibility.Private, new System.Delegate[] {
                new Microsoft.Scripting.Function<System.Object, System.Double, System.Double>(Ruby.Builtins.Math.Exp),
            });
            
            module.DefineInstanceMethod("log", Ruby.Runtime.RubyMethodVisibility.Private, new System.Delegate[] {
                new Microsoft.Scripting.Function<System.Object, System.Double, System.Double>(Ruby.Builtins.Math.Log),
            });
            
            module.DefineInstanceMethod("log10", Ruby.Runtime.RubyMethodVisibility.Private, new System.Delegate[] {
                new Microsoft.Scripting.Function<System.Object, System.Double, System.Double>(Ruby.Builtins.Math.Log10),
            });
            
            module.DefineInstanceMethod("sin", Ruby.Runtime.RubyMethodVisibility.Private, new System.Delegate[] {
                new Microsoft.Scripting.Function<System.Object, System.Double, System.Double>(Ruby.Builtins.Math.Sin),
            });
            
            module.DefineInstanceMethod("sinh", Ruby.Runtime.RubyMethodVisibility.Private, new System.Delegate[] {
                new Microsoft.Scripting.Function<System.Object, System.Double, System.Double>(Ruby.Builtins.Math.Sinh),
            });
            
            module.DefineInstanceMethod("sqrt", Ruby.Runtime.RubyMethodVisibility.Private, new System.Delegate[] {
                new Microsoft.Scripting.Function<System.Object, System.Double, System.Double>(Ruby.Builtins.Math.Sqrt),
            });
            
            module.DefineInstanceMethod("tan", Ruby.Runtime.RubyMethodVisibility.Private, new System.Delegate[] {
                new Microsoft.Scripting.Function<System.Object, System.Double, System.Double>(Ruby.Builtins.Math.Tan),
            });
            
            module.DefineInstanceMethod("tanh", Ruby.Runtime.RubyMethodVisibility.Private, new System.Delegate[] {
                new Microsoft.Scripting.Function<System.Object, System.Double, System.Double>(Ruby.Builtins.Math.Tanh),
            });
            
            module.DefineClassMethod("acos", Ruby.Runtime.RubyMethodVisibility.Public, new System.Delegate[] {
                new Microsoft.Scripting.Function<System.Object, System.Double, System.Double>(Ruby.Builtins.Math.Acos),
            });
            
            module.DefineClassMethod("asin", Ruby.Runtime.RubyMethodVisibility.Public, new System.Delegate[] {
                new Microsoft.Scripting.Function<System.Object, System.Double, System.Double>(Ruby.Builtins.Math.Asin),
            });
            
            module.DefineClassMethod("atan", Ruby.Runtime.RubyMethodVisibility.Public, new System.Delegate[] {
                new Microsoft.Scripting.Function<System.Object, System.Double, System.Double>(Ruby.Builtins.Math.Atan),
            });
            
            module.DefineClassMethod("atan2", Ruby.Runtime.RubyMethodVisibility.Public, new System.Delegate[] {
                new Microsoft.Scripting.Function<System.Object, System.Double, System.Double, System.Double>(Ruby.Builtins.Math.Atan2),
            });
            
            module.DefineClassMethod("cos", Ruby.Runtime.RubyMethodVisibility.Public, new System.Delegate[] {
                new Microsoft.Scripting.Function<System.Object, System.Double, System.Double>(Ruby.Builtins.Math.Cos),
            });
            
            module.DefineClassMethod("cosh", Ruby.Runtime.RubyMethodVisibility.Public, new System.Delegate[] {
                new Microsoft.Scripting.Function<System.Object, System.Double, System.Double>(Ruby.Builtins.Math.Cosh),
            });
            
            module.DefineClassMethod("exp", Ruby.Runtime.RubyMethodVisibility.Public, new System.Delegate[] {
                new Microsoft.Scripting.Function<System.Object, System.Double, System.Double>(Ruby.Builtins.Math.Exp),
            });
            
            module.DefineClassMethod("log", Ruby.Runtime.RubyMethodVisibility.Public, new System.Delegate[] {
                new Microsoft.Scripting.Function<System.Object, System.Double, System.Double>(Ruby.Builtins.Math.Log),
            });
            
            module.DefineClassMethod("log10", Ruby.Runtime.RubyMethodVisibility.Public, new System.Delegate[] {
                new Microsoft.Scripting.Function<System.Object, System.Double, System.Double>(Ruby.Builtins.Math.Log10),
            });
            
            module.DefineClassMethod("sin", Ruby.Runtime.RubyMethodVisibility.Public, new System.Delegate[] {
                new Microsoft.Scripting.Function<System.Object, System.Double, System.Double>(Ruby.Builtins.Math.Sin),
            });
            
            module.DefineClassMethod("sinh", Ruby.Runtime.RubyMethodVisibility.Public, new System.Delegate[] {
                new Microsoft.Scripting.Function<System.Object, System.Double, System.Double>(Ruby.Builtins.Math.Sinh),
            });
            
            module.DefineClassMethod("sqrt", Ruby.Runtime.RubyMethodVisibility.Public, new System.Delegate[] {
                new Microsoft.Scripting.Function<System.Object, System.Double, System.Double>(Ruby.Builtins.Math.Sqrt),
            });
            
            module.DefineClassMethod("tan", Ruby.Runtime.RubyMethodVisibility.Public, new System.Delegate[] {
                new Microsoft.Scripting.Function<System.Object, System.Double, System.Double>(Ruby.Builtins.Math.Tan),
            });
            
            module.DefineClassMethod("tanh", Ruby.Runtime.RubyMethodVisibility.Public, new System.Delegate[] {
                new Microsoft.Scripting.Function<System.Object, System.Double, System.Double>(Ruby.Builtins.Math.Tanh),
            });
            
        }
        
        private void LoadMethod(Ruby.Builtins.RubyModule/*!*/ module) {
        }
        
        private void LoadMutableString(Ruby.Builtins.RubyModule/*!*/ module) {
            module.DefineInstanceMethod("*", Ruby.Runtime.RubyMethodVisibility.Public, new System.Delegate[] {
                new Microsoft.Scripting.Function<Ruby.Builtins.MutableString, System.Int32, Ruby.Builtins.MutableString>(Ruby.Builtins.MutableString.Repeat),
                new Microsoft.Scripting.Function<Ruby.Builtins.MutableString, System.Object, Ruby.Builtins.MutableString>(Ruby.Builtins.MutableString.Repeat),
            });
            
            module.DefineInstanceMethod("+", Ruby.Runtime.RubyMethodVisibility.Public, new System.Delegate[] {
                new Microsoft.Scripting.Function<Ruby.Builtins.MutableString, Ruby.Builtins.MutableString, Ruby.Builtins.MutableString>(Ruby.Builtins.MutableString.Concatenate),
                new Microsoft.Scripting.Function<Microsoft.Scripting.CodeContext, Ruby.Builtins.MutableString, System.Object, Ruby.Builtins.MutableString>(Ruby.Builtins.MutableString.Concatenate),
            });
            
            module.DefineInstanceMethod("<<", Ruby.Runtime.RubyMethodVisibility.Public, new System.Delegate[] {
                new Microsoft.Scripting.Function<Ruby.Builtins.MutableString, Ruby.Builtins.MutableString, Ruby.Builtins.MutableString>(Ruby.Builtins.MutableString.Append),
                new Microsoft.Scripting.Function<Ruby.Builtins.MutableString, System.Int32, Ruby.Builtins.MutableString>(Ruby.Builtins.MutableString.Append),
                new Microsoft.Scripting.Function<Ruby.Builtins.MutableString, System.Object, Ruby.Builtins.MutableString>(Ruby.Builtins.MutableString.Append),
            });
            
            module.DefineInstanceMethod("concat", Ruby.Runtime.RubyMethodVisibility.Public, new System.Delegate[] {
                new Microsoft.Scripting.Function<Ruby.Builtins.MutableString, Ruby.Builtins.MutableString, Ruby.Builtins.MutableString>(Ruby.Builtins.MutableString.Append),
                new Microsoft.Scripting.Function<Ruby.Builtins.MutableString, System.Int32, Ruby.Builtins.MutableString>(Ruby.Builtins.MutableString.Append),
                new Microsoft.Scripting.Function<Ruby.Builtins.MutableString, System.Object, Ruby.Builtins.MutableString>(Ruby.Builtins.MutableString.Append),
            });
            
            module.DefineInstanceMethod("<=>", Ruby.Runtime.RubyMethodVisibility.Public, new System.Delegate[] {
                new Microsoft.Scripting.Function<Ruby.Builtins.MutableString, Ruby.Builtins.MutableString, System.Int32>(Ruby.Builtins.MutableString.Compare),
                new Microsoft.Scripting.Function<Ruby.Builtins.MutableString, System.Object, System.Object>(Ruby.Builtins.MutableString.Compare),
            });
            
            module.DefineInstanceMethod("===", Ruby.Runtime.RubyMethodVisibility.Public, new System.Delegate[] {
                new Microsoft.Scripting.Function<Ruby.Builtins.MutableString, Ruby.Builtins.MutableString, System.Boolean>(Ruby.Builtins.MutableString.StringEquals),
                new Microsoft.Scripting.Function<Ruby.Builtins.MutableString, System.Object, System.Boolean>(Ruby.Builtins.MutableString.Equals),
            });
            
            module.DefineInstanceMethod("==", Ruby.Runtime.RubyMethodVisibility.Public, new System.Delegate[] {
                new Microsoft.Scripting.Function<Ruby.Builtins.MutableString, Ruby.Builtins.MutableString, System.Boolean>(Ruby.Builtins.MutableString.StringEquals),
                new Microsoft.Scripting.Function<Ruby.Builtins.MutableString, System.Object, System.Boolean>(Ruby.Builtins.MutableString.Equals),
            });
            
            module.DefineInstanceMethod("[]", Ruby.Runtime.RubyMethodVisibility.Public, new System.Delegate[] {
                new Microsoft.Scripting.Function<Ruby.Builtins.MutableString, System.Int32, System.Object>(Ruby.Builtins.MutableString.GetChar),
                new Microsoft.Scripting.Function<Ruby.Builtins.MutableString, System.Object, System.Object>(Ruby.Builtins.MutableString.GetChar),
                new Microsoft.Scripting.Function<Ruby.Builtins.MutableString, System.Int32, System.Int32, Ruby.Builtins.MutableString>(Ruby.Builtins.MutableString.GetChars),
                new Microsoft.Scripting.Function<Ruby.Builtins.MutableString, System.Int32, System.Object, Ruby.Builtins.MutableString>(Ruby.Builtins.MutableString.GetChars),
                new Microsoft.Scripting.Function<Ruby.Builtins.MutableString, System.Object, System.Int32, Ruby.Builtins.MutableString>(Ruby.Builtins.MutableString.GetChars),
                new Microsoft.Scripting.Function<Ruby.Builtins.MutableString, System.Object, System.Object, Ruby.Builtins.MutableString>(Ruby.Builtins.MutableString.GetChars),
                new Microsoft.Scripting.Function<Ruby.Builtins.MutableString, Ruby.Builtins.Range, Ruby.Builtins.MutableString>(Ruby.Builtins.MutableString.GetChars),
                new Microsoft.Scripting.Function<Ruby.Builtins.MutableString, System.String, Ruby.Builtins.MutableString>(Ruby.Builtins.MutableString.GetChars),
                new Microsoft.Scripting.Function<Ruby.Builtins.MutableString, Ruby.Builtins.MutableString, Ruby.Builtins.MutableString>(Ruby.Builtins.MutableString.GetChars),
                new Microsoft.Scripting.Function<Ruby.Builtins.MutableString, System.Text.RegularExpressions.Regex, Ruby.Builtins.MutableString>(Ruby.Builtins.MutableString.GetChars),
                new Microsoft.Scripting.Function<Ruby.Builtins.MutableString, System.Text.RegularExpressions.Regex, System.Int32, Ruby.Builtins.MutableString>(Ruby.Builtins.MutableString.GetChars),
            });
            
            module.DefineInstanceMethod("[]=", Ruby.Runtime.RubyMethodVisibility.Public, new System.Delegate[] {
                new Microsoft.Scripting.Function<Ruby.Builtins.MutableString, System.Int32, Ruby.Builtins.MutableString, Ruby.Builtins.MutableString>(Ruby.Builtins.MutableString.SetChar),
                new Microsoft.Scripting.Function<Ruby.Builtins.MutableString, System.Int32, System.Int32, System.Int32>(Ruby.Builtins.MutableString.SetChar),
                new Microsoft.Scripting.Function<Ruby.Builtins.MutableString, System.Object, System.Int32, System.Int32>(Ruby.Builtins.MutableString.SetChar),
                new Microsoft.Scripting.Function<Ruby.Builtins.MutableString, System.Int32, System.Object, System.Object>(Ruby.Builtins.MutableString.SetChar),
                new Microsoft.Scripting.Function<Ruby.Builtins.MutableString, System.Object, System.Object, System.Object>(Ruby.Builtins.MutableString.SetChar),
                new Microsoft.Scripting.Function<Ruby.Builtins.MutableString, System.Int32, System.Int32, Ruby.Builtins.MutableString, Ruby.Builtins.MutableString>(Ruby.Builtins.MutableString.SetChar),
                new Microsoft.Scripting.Function<Ruby.Builtins.MutableString, System.Int32, System.Int32, System.Object, Ruby.Builtins.MutableString>(Ruby.Builtins.MutableString.SetChar),
                new Microsoft.Scripting.Function<Ruby.Builtins.MutableString, Ruby.Builtins.Range, Ruby.Builtins.MutableString, Ruby.Builtins.MutableString>(Ruby.Builtins.MutableString.SetChar),
            });
            
            module.DefineInstanceMethod("capitalize!", Ruby.Runtime.RubyMethodVisibility.Public, new System.Delegate[] {
                new Microsoft.Scripting.Function<Ruby.Builtins.MutableString, Ruby.Builtins.MutableString>(Ruby.Builtins.MutableString.CapitalizeInPlace),
            });
            
            module.DefineInstanceMethod("capitalize", Ruby.Runtime.RubyMethodVisibility.Public, new System.Delegate[] {
                new Microsoft.Scripting.Function<Ruby.Builtins.MutableString, Ruby.Builtins.MutableString>(Ruby.Builtins.MutableString.Capitalize),
            });
            
            module.DefineInstanceMethod("downcase", Ruby.Runtime.RubyMethodVisibility.Public, new System.Delegate[] {
                new Microsoft.Scripting.Function<Ruby.Builtins.MutableString, Ruby.Builtins.MutableString>(Ruby.Builtins.MutableString.DownCase),
            });
            
            module.DefineInstanceMethod("downcase!", Ruby.Runtime.RubyMethodVisibility.Public, new System.Delegate[] {
                new Microsoft.Scripting.Function<Ruby.Builtins.MutableString, Ruby.Builtins.MutableString>(Ruby.Builtins.MutableString.DownCaseInPlace),
            });
            
            module.DefineInstanceMethod("dump", Ruby.Runtime.RubyMethodVisibility.Public, new System.Delegate[] {
                new Microsoft.Scripting.Function<Ruby.Builtins.MutableString, Ruby.Builtins.MutableString>(Ruby.Builtins.MutableString.Dump),
            });
            
            module.DefineInstanceMethod("inspect", Ruby.Runtime.RubyMethodVisibility.Public, new System.Delegate[] {
                new Microsoft.Scripting.Function<Ruby.Builtins.MutableString, Ruby.Builtins.MutableString>(Ruby.Builtins.MutableString.Dump),
            });
            
            module.DefineInstanceMethod("each_byte", Ruby.Runtime.RubyMethodVisibility.Public, new System.Delegate[] {
                new Microsoft.Scripting.Function<Microsoft.Scripting.CodeContext, Ruby.Builtins.MutableString, Ruby.Builtins.Proc, Ruby.Builtins.MutableString>(Ruby.Builtins.MutableString.EachByte),
            });
            
            module.DefineInstanceMethod("each", Ruby.Runtime.RubyMethodVisibility.Public, new System.Delegate[] {
                new Microsoft.Scripting.Function<Microsoft.Scripting.CodeContext, System.Object, System.Object, System.Object>(Ruby.Builtins.MutableString.EachLine),
            });
            
            module.DefineInstanceMethod("each_line", Ruby.Runtime.RubyMethodVisibility.Public, new System.Delegate[] {
                new Microsoft.Scripting.Function<Microsoft.Scripting.CodeContext, System.Object, System.Object, System.Object>(Ruby.Builtins.MutableString.EachLine),
            });
            
            module.DefineInstanceMethod("empty?", Ruby.Runtime.RubyMethodVisibility.Public, new System.Delegate[] {
                new Microsoft.Scripting.Function<Ruby.Builtins.MutableString, System.Boolean>(Ruby.Builtins.MutableString.Empty),
            });
            
            module.DefineInstanceMethod("index", Ruby.Runtime.RubyMethodVisibility.Public, new System.Delegate[] {
                new Microsoft.Scripting.Function<Ruby.Builtins.MutableString, System.String, System.Object>(Ruby.Builtins.MutableString.Index),
                new Microsoft.Scripting.Function<Ruby.Builtins.MutableString, Ruby.Builtins.MutableString, System.Object>(Ruby.Builtins.MutableString.Index),
                new Microsoft.Scripting.Function<Ruby.Builtins.MutableString, System.Object, System.Object>(Ruby.Builtins.MutableString.Index),
                new Microsoft.Scripting.Function<Ruby.Builtins.MutableString, System.String, System.Int32, System.Object>(Ruby.Builtins.MutableString.Index),
                new Microsoft.Scripting.Function<Ruby.Builtins.MutableString, Ruby.Builtins.MutableString, System.Int32, System.Object>(Ruby.Builtins.MutableString.Index),
                new Microsoft.Scripting.Function<Ruby.Builtins.MutableString, Ruby.Builtins.MutableString, System.Object, System.Object>(Ruby.Builtins.MutableString.Index),
                new Microsoft.Scripting.Function<Ruby.Builtins.MutableString, System.Object, System.Int32, System.Object>(Ruby.Builtins.MutableString.Index),
                new Microsoft.Scripting.Function<Ruby.Builtins.MutableString, System.Object, System.Object, System.Object>(Ruby.Builtins.MutableString.Index),
                new Microsoft.Scripting.Function<Ruby.Builtins.MutableString, System.Int32, System.Object>(Ruby.Builtins.MutableString.Index),
                new Microsoft.Scripting.Function<Ruby.Builtins.MutableString, System.Int32, System.Int32, System.Object>(Ruby.Builtins.MutableString.Index),
                new Microsoft.Scripting.Function<Ruby.Builtins.MutableString, System.Int32, System.Object, System.Object>(Ruby.Builtins.MutableString.Index),
                new Microsoft.Scripting.Function<Ruby.Builtins.MutableString, System.Text.RegularExpressions.Regex, System.Object>(Ruby.Builtins.MutableString.Index),
                new Microsoft.Scripting.Function<Ruby.Builtins.MutableString, System.Text.RegularExpressions.Regex, System.Int32, System.Object>(Ruby.Builtins.MutableString.Index),
            });
            
            module.DefineInstanceMethod("include?", Ruby.Runtime.RubyMethodVisibility.Public, new System.Delegate[] {
                new Microsoft.Scripting.Function<Ruby.Builtins.MutableString, System.String, System.Boolean>(Ruby.Builtins.MutableString.Include),
                new Microsoft.Scripting.Function<Ruby.Builtins.MutableString, System.Object, System.Boolean>(Ruby.Builtins.MutableString.Include),
                new Microsoft.Scripting.Function<Ruby.Builtins.MutableString, Ruby.Builtins.MutableString, System.Boolean>(Ruby.Builtins.MutableString.Include),
                new Microsoft.Scripting.Function<Ruby.Builtins.MutableString, System.Int32, System.Boolean>(Ruby.Builtins.MutableString.Include),
            });
            
            module.DefineInstanceMethod("insert", Ruby.Runtime.RubyMethodVisibility.Public, new System.Delegate[] {
                new Microsoft.Scripting.Function<Ruby.Builtins.MutableString, System.Int32, System.String, Ruby.Builtins.MutableString>(Ruby.Builtins.MutableString.Insert),
                new Microsoft.Scripting.Function<Ruby.Builtins.MutableString, System.Int32, Ruby.Builtins.MutableString, Ruby.Builtins.MutableString>(Ruby.Builtins.MutableString.Insert),
                new Microsoft.Scripting.Function<Ruby.Builtins.MutableString, System.Int32, System.Object, Ruby.Builtins.MutableString>(Ruby.Builtins.MutableString.Insert),
            });
            
            module.DefineInstanceMethod("size", Ruby.Runtime.RubyMethodVisibility.Public, new System.Delegate[] {
                new Microsoft.Scripting.Function<Ruby.Builtins.MutableString, System.Int32>(Ruby.Builtins.MutableString.MutableStringLength),
            });
            
            module.DefineInstanceMethod("length", Ruby.Runtime.RubyMethodVisibility.Public, new System.Delegate[] {
                new Microsoft.Scripting.Function<Ruby.Builtins.MutableString, System.Int32>(Ruby.Builtins.MutableString.MutableStringLength),
            });
            
            module.DefineInstanceMethod("succ!", Ruby.Runtime.RubyMethodVisibility.Public, new System.Delegate[] {
                new Microsoft.Scripting.Function<Ruby.Builtins.MutableString, Ruby.Builtins.MutableString>(Ruby.Builtins.MutableString.SuccInPlace),
            });
            
            module.DefineInstanceMethod("succ", Ruby.Runtime.RubyMethodVisibility.Public, new System.Delegate[] {
                new Microsoft.Scripting.Function<Ruby.Builtins.MutableString, Ruby.Builtins.MutableString>(Ruby.Builtins.MutableString.Succ),
            });
            
            module.DefineInstanceMethod("upcase", Ruby.Runtime.RubyMethodVisibility.Public, new System.Delegate[] {
                new Microsoft.Scripting.Function<Ruby.Builtins.MutableString, Ruby.Builtins.MutableString>(Ruby.Builtins.MutableString.UpCase),
            });
            
            module.DefineInstanceMethod("upcase!", Ruby.Runtime.RubyMethodVisibility.Public, new System.Delegate[] {
                new Microsoft.Scripting.Function<Ruby.Builtins.MutableString, Ruby.Builtins.MutableString>(Ruby.Builtins.MutableString.UpCaseInPlace),
            });
            
            module.DefineInstanceMethod("split", Ruby.Runtime.RubyMethodVisibility.Public, new System.Delegate[] {
                new Microsoft.Scripting.Function<Microsoft.Scripting.CodeContext, Ruby.Builtins.MutableString, System.Collections.Generic.List<System.Object>>(Ruby.Builtins.MutableString.Split),
            });
            
            module.DefineInstanceMethod("to_clr_string", Ruby.Runtime.RubyMethodVisibility.Public, new System.Delegate[] {
                new Microsoft.Scripting.Function<Ruby.Builtins.MutableString, System.String>(Ruby.Builtins.MutableString.ToClrString),
            });
            
            module.DefineInstanceMethod("to_str", Ruby.Runtime.RubyMethodVisibility.Public, new System.Delegate[] {
                new Microsoft.Scripting.Function<Ruby.Builtins.MutableString, Ruby.Builtins.MutableString>(Ruby.Builtins.MutableString.ToS),
            });
            
            module.DefineInstanceMethod("to_s", Ruby.Runtime.RubyMethodVisibility.Public, new System.Delegate[] {
                new Microsoft.Scripting.Function<Ruby.Builtins.MutableString, Ruby.Builtins.MutableString>(Ruby.Builtins.MutableString.ToS),
            });
            
        }
        
        private void LoadObject(Ruby.Builtins.RubyModule/*!*/ module) {
            module.DefineInstanceMethod("to_s", Ruby.Runtime.RubyMethodVisibility.Public, new System.Delegate[] {
                new Microsoft.Scripting.Function<Microsoft.Scripting.CodeContext, System.Object, Ruby.Builtins.MutableString>(Ruby.Builtins.ObjectOps.ToString),
            });
            
            module.DefineInstanceMethod("inspect", Ruby.Runtime.RubyMethodVisibility.Public, new System.Delegate[] {
                new Microsoft.Scripting.Function<Microsoft.Scripting.CodeContext, System.Object, Ruby.Builtins.MutableString>(Ruby.Builtins.ObjectOps.ToString),
            });
            
            module.DefineInstanceMethod("class", Ruby.Runtime.RubyMethodVisibility.Public, new System.Delegate[] {
                new Microsoft.Scripting.Function<Microsoft.Scripting.CodeContext, System.Object, Ruby.Builtins.RubyClass>(Ruby.Builtins.ObjectOps.GetClass),
            });
            
            module.DefineInstanceMethod("id", Ruby.Runtime.RubyMethodVisibility.Public, new System.Delegate[] {
                new Microsoft.Scripting.Function<System.Object, System.Int32>(Ruby.Builtins.ObjectOps.GetId),
            });
            
            module.DefineInstanceMethod("object_id", Ruby.Runtime.RubyMethodVisibility.Public, new System.Delegate[] {
                new Microsoft.Scripting.Function<System.Object, System.Int32>(Ruby.Builtins.ObjectOps.GetObjectId),
            });
            
            module.DefineInstanceMethod("equal?", Ruby.Runtime.RubyMethodVisibility.Public, new System.Delegate[] {
                new Microsoft.Scripting.Function<System.Object, System.Object, System.Boolean>(Ruby.Builtins.ObjectOps.Equal),
            });
            
            module.DefineInstanceMethod("==", Ruby.Runtime.RubyMethodVisibility.Public, new System.Delegate[] {
                new Microsoft.Scripting.Function<System.Object, System.Object, System.Boolean>(Ruby.Builtins.ObjectOps.Equals),
            });
            
            module.DefineInstanceMethod("nil?", Ruby.Runtime.RubyMethodVisibility.Public, new System.Delegate[] {
                new Microsoft.Scripting.Function<System.Object, System.Boolean>(Ruby.Builtins.ObjectOps.IsNil),
            });
            
            module.DefineInstanceMethod("is_a?", Ruby.Runtime.RubyMethodVisibility.Public, new System.Delegate[] {
                new Microsoft.Scripting.Function<System.Object, Ruby.Builtins.RubyModule, System.Boolean>(Ruby.Builtins.ObjectOps.IsKindOf),
            });
            
            module.DefineInstanceMethod("kind_of?", Ruby.Runtime.RubyMethodVisibility.Public, new System.Delegate[] {
                new Microsoft.Scripting.Function<System.Object, Ruby.Builtins.RubyModule, System.Boolean>(Ruby.Builtins.ObjectOps.IsKindOf),
            });
            
            module.DefineInstanceMethod("instance_of?", Ruby.Runtime.RubyMethodVisibility.Public, new System.Delegate[] {
                new Microsoft.Scripting.Function<System.Object, Ruby.Builtins.RubyModule, System.Boolean>(Ruby.Builtins.ObjectOps.IsOfClass),
            });
            
            module.DefineInstanceMethod("respond_to?", Ruby.Runtime.RubyMethodVisibility.Public, new System.Delegate[] {
                new Microsoft.Scripting.Function<Microsoft.Scripting.CodeContext, System.Object, Ruby.Builtins.MutableString, System.Boolean>(Ruby.Builtins.ObjectOps.RespondTo),
                new Microsoft.Scripting.Function<Microsoft.Scripting.CodeContext, System.Object, Microsoft.Scripting.SymbolId, System.Boolean>(Ruby.Builtins.ObjectOps.RespondTo),
            });
            
        }
        
        private void LoadTrueClass(Ruby.Builtins.RubyModule/*!*/ module) {
            module.DefineInstanceMethod("to_s", Ruby.Runtime.RubyMethodVisibility.Public, new System.Delegate[] {
                new Microsoft.Scripting.Function<System.Boolean, Ruby.Builtins.MutableString>(Ruby.Builtins.TrueClass.ToString),
            });
            
            module.DefineInstanceMethod("inspect", Ruby.Runtime.RubyMethodVisibility.Public, new System.Delegate[] {
                new Microsoft.Scripting.Function<System.Boolean, Ruby.Builtins.MutableString>(Ruby.Builtins.TrueClass.ToString),
            });
            
            module.DefineInstanceMethod("&", Ruby.Runtime.RubyMethodVisibility.Public, new System.Delegate[] {
                new Microsoft.Scripting.Function<System.Boolean, System.Object, System.Boolean>(Ruby.Builtins.TrueClass.And),
                new Microsoft.Scripting.Function<System.Boolean, System.Boolean, System.Boolean>(Ruby.Builtins.TrueClass.And),
            });
            
            module.DefineInstanceMethod("^", Ruby.Runtime.RubyMethodVisibility.Public, new System.Delegate[] {
                new Microsoft.Scripting.Function<System.Boolean, System.Object, System.Boolean>(Ruby.Builtins.TrueClass.Xor),
                new Microsoft.Scripting.Function<System.Boolean, System.Boolean, System.Boolean>(Ruby.Builtins.TrueClass.Xor),
            });
            
            module.DefineInstanceMethod("|", Ruby.Runtime.RubyMethodVisibility.Public, new System.Delegate[] {
                new Microsoft.Scripting.Function<System.Boolean, System.Object, System.Boolean>(Ruby.Builtins.TrueClass.Or),
            });
            
        }
        
        private void LoadNumeric(Ruby.Builtins.RubyModule/*!*/ module) {
            module.DefineInstanceMethod("to_int", Ruby.Runtime.RubyMethodVisibility.Public, new System.Delegate[] {
                new Microsoft.Scripting.Function<System.Object, System.Int32>(Ruby.Builtins.Numeric.ToInt),
            });
            
        }
        
        private void LoadInteger(Ruby.Builtins.RubyModule/*!*/ module) {
            module.DefineInstanceMethod("succ", Ruby.Runtime.RubyMethodVisibility.Public, new System.Delegate[] {
                new Microsoft.Scripting.Function<System.Int32, System.Int32>(Ruby.Builtins.Integer.Succ),
            });
            
            module.DefineInstanceMethod("times", Ruby.Runtime.RubyMethodVisibility.Public, new System.Delegate[] {
                new Microsoft.Scripting.Function<Microsoft.Scripting.CodeContext, System.Int32, Ruby.Builtins.Proc, System.Object>(Ruby.Builtins.Integer.Times),
                new Microsoft.Scripting.Function<Microsoft.Scripting.CodeContext, Microsoft.Scripting.Math.BigInteger, Ruby.Builtins.Proc, System.Object>(Ruby.Builtins.Integer.Times),
            });
            
        }
        
        private void LoadBignum(Ruby.Builtins.RubyModule/*!*/ module) {
        }
        
        private void LoadModule(Ruby.Builtins.RubyModule/*!*/ module) {
            module.DefineInstanceMethod("append_features", Ruby.Runtime.RubyMethodVisibility.Private, new System.Delegate[] {
                new Microsoft.Scripting.Function<Ruby.Builtins.RubyModule, Ruby.Builtins.RubyModule, Ruby.Builtins.RubyModule>(Ruby.Builtins.RubyModule.AppendFeatures),
            });
            
            module.DefineInstanceMethod("include", Ruby.Runtime.RubyMethodVisibility.Private, new System.Delegate[] {
                new Microsoft.Scripting.Function<Ruby.Builtins.RubyModule, Ruby.Builtins.RubyModule[], Ruby.Builtins.RubyModule>(Ruby.Builtins.RubyModule.Include),
            });
            
            module.DefineInstanceMethod("included", Ruby.Runtime.RubyMethodVisibility.Private, new System.Delegate[] {
                new Microsoft.Scripting.Function<Ruby.Builtins.RubyModule, Ruby.Builtins.RubyModule, Ruby.Builtins.RubyModule>(Ruby.Builtins.RubyModule.Included),
            });
            
            module.DefineInstanceMethod("private", Ruby.Runtime.RubyMethodVisibility.Private, new System.Delegate[] {
                new Microsoft.Scripting.Function<Microsoft.Scripting.CodeContext, Ruby.Builtins.RubyModule, Microsoft.Scripting.SymbolId[], Ruby.Builtins.RubyModule>(Ruby.Builtins.RubyModule.SetPrivateVisibility),
            });
            
            module.DefineInstanceMethod("protected", Ruby.Runtime.RubyMethodVisibility.Private, new System.Delegate[] {
                new Microsoft.Scripting.Function<Microsoft.Scripting.CodeContext, Ruby.Builtins.RubyModule, Microsoft.Scripting.SymbolId[], Ruby.Builtins.RubyModule>(Ruby.Builtins.RubyModule.SetProtectedVisibility),
            });
            
            module.DefineInstanceMethod("public", Ruby.Runtime.RubyMethodVisibility.Private, new System.Delegate[] {
                new Microsoft.Scripting.Function<Microsoft.Scripting.CodeContext, Ruby.Builtins.RubyModule, Microsoft.Scripting.SymbolId[], Ruby.Builtins.RubyModule>(Ruby.Builtins.RubyModule.SetPublicVisibility),
            });
            
            module.DefineInstanceMethod("===", Ruby.Runtime.RubyMethodVisibility.Public, new System.Delegate[] {
                new Microsoft.Scripting.Function<Ruby.Builtins.RubyModule, System.Object, System.Boolean>(Ruby.Builtins.RubyModule.CaseEquals),
            });
            
            module.DefineInstanceMethod("class_eval", Ruby.Runtime.RubyMethodVisibility.Public, new System.Delegate[] {
                new Microsoft.Scripting.Function<System.Object, System.String, System.Object>(Ruby.Builtins.RubyModule.Evaluate),
                new Microsoft.Scripting.Function<System.Object, System.String, System.String, System.Object>(Ruby.Builtins.RubyModule.Evaluate),
                new Microsoft.Scripting.Function<System.Object, System.String, System.String, System.Int32, System.Object>(Ruby.Builtins.RubyModule.Evaluate),
                new Microsoft.Scripting.Function<System.Object, System.Object, System.Object>(Ruby.Builtins.RubyModule.Evaluate),
            });
            
            module.DefineInstanceMethod("constants", Ruby.Runtime.RubyMethodVisibility.Public, new System.Delegate[] {
                new Microsoft.Scripting.Function<Ruby.Builtins.RubyModule, System.Collections.Generic.List<System.Object>>(Ruby.Builtins.RubyModule.GetDefinedConstants),
            });
            
            module.DefineInstanceMethod("instance_method", Ruby.Runtime.RubyMethodVisibility.Public, new System.Delegate[] {
                new Microsoft.Scripting.Function<Ruby.Builtins.RubyModule, Microsoft.Scripting.SymbolId, Ruby.Builtins.UnboundMethod>(Ruby.Builtins.RubyModule.GetInstanceMethod),
            });
            
        }
        
        private void LoadClass(Ruby.Builtins.RubyModule/*!*/ module) {
            module.DefineInstanceMethod("allocate", Ruby.Runtime.RubyMethodVisibility.Public, Ruby.Runtime.MethodKind.InstanceAllocator, new System.Delegate[] {
                new Microsoft.Scripting.Function<Ruby.Builtins.RubyClass, System.Object>(Ruby.Builtins.RubyClass.Allocate),
            });
            
            module.DefineInstanceMethod("new", Ruby.Runtime.RubyMethodVisibility.Public, Ruby.Runtime.MethodKind.InstanceConstructor, new System.Delegate[] {
                new Microsoft.Scripting.Function<Ruby.Builtins.RubyClass, System.Object[], System.Object>(Ruby.Builtins.RubyClass.New),
            });
            
            module.DefineInstanceMethod("to_s", Ruby.Runtime.RubyMethodVisibility.Public, new System.Delegate[] {
                new Microsoft.Scripting.Function<Ruby.Builtins.RubyClass, Ruby.Builtins.MutableString>(Ruby.Builtins.RubyClass.GetName),
                new Microsoft.Scripting.Function<Microsoft.Scripting.DynamicType, Ruby.Builtins.MutableString>(Ruby.Builtins.RubyClass.GetName),
            });
            
            module.DefineInstanceMethod("inspect", Ruby.Runtime.RubyMethodVisibility.Public, new System.Delegate[] {
                new Microsoft.Scripting.Function<Ruby.Builtins.RubyClass, Ruby.Builtins.MutableString>(Ruby.Builtins.RubyClass.GetName),
                new Microsoft.Scripting.Function<Microsoft.Scripting.DynamicType, Ruby.Builtins.MutableString>(Ruby.Builtins.RubyClass.GetName),
            });
            
            module.DefineInstanceMethod("name", Ruby.Runtime.RubyMethodVisibility.Public, new System.Delegate[] {
                new Microsoft.Scripting.Function<Ruby.Builtins.RubyClass, Ruby.Builtins.MutableString>(Ruby.Builtins.RubyClass.GetName),
                new Microsoft.Scripting.Function<Microsoft.Scripting.DynamicType, Ruby.Builtins.MutableString>(Ruby.Builtins.RubyClass.GetName),
            });
            
            module.DefineInstanceMethod("superclass", Ruby.Runtime.RubyMethodVisibility.Public, new System.Delegate[] {
                new Microsoft.Scripting.Function<Ruby.Builtins.RubyClass, Ruby.Builtins.RubyClass>(Ruby.Builtins.RubyClass.GetSuperclass),
                new Microsoft.Scripting.Function<Microsoft.Scripting.DynamicType, Microsoft.Scripting.DynamicType>(Ruby.Builtins.RubyClass.GetSuperclass),
            });
            
        }
        
        private void LoadComparable(Ruby.Builtins.RubyModule/*!*/ module) {
        }
        
        private void LoadEnumerable(Ruby.Builtins.RubyModule/*!*/ module) {
        }
        
        private void LoadFixnum(Ruby.Builtins.RubyModule/*!*/ module) {
            module.DefineInstanceMethod("+", Ruby.Runtime.RubyMethodVisibility.Public, new System.Delegate[] {
                new Microsoft.Scripting.Function<System.Int32, System.Int32, System.Object>(Ruby.Builtins.FixnumOps.Add),
                new Microsoft.Scripting.Function<System.Int32, Microsoft.Scripting.Math.BigInteger, Microsoft.Scripting.Math.BigInteger>(Ruby.Builtins.FixnumOps.Add),
            });
            
            module.DefineInstanceMethod("-", Ruby.Runtime.RubyMethodVisibility.Public, new System.Delegate[] {
                new Microsoft.Scripting.Function<System.Int32, System.Int32, System.Object>(Ruby.Builtins.FixnumOps.Subtract),
            });
            
            module.DefineInstanceMethod("*", Ruby.Runtime.RubyMethodVisibility.Public, new System.Delegate[] {
                new Microsoft.Scripting.Function<System.Int32, System.Int32, System.Object>(Ruby.Builtins.FixnumOps.Multiply),
            });
            
            module.DefineInstanceMethod("/", Ruby.Runtime.RubyMethodVisibility.Public, new System.Delegate[] {
                new Microsoft.Scripting.Function<System.Int32, System.Int32, System.Object>(Ruby.Builtins.FixnumOps.Divide),
            });
            
            module.DefineInstanceMethod(">", Ruby.Runtime.RubyMethodVisibility.Public, new System.Delegate[] {
                new Microsoft.Scripting.Function<System.Int32, System.Int32, System.Boolean>(Ruby.Builtins.FixnumOps.GraterThan),
            });
            
            module.DefineInstanceMethod(">=", Ruby.Runtime.RubyMethodVisibility.Public, new System.Delegate[] {
                new Microsoft.Scripting.Function<System.Int32, System.Int32, System.Boolean>(Ruby.Builtins.FixnumOps.GreaterThanOrEqual),
            });
            
            module.DefineInstanceMethod("<", Ruby.Runtime.RubyMethodVisibility.Public, new System.Delegate[] {
                new Microsoft.Scripting.Function<System.Int32, System.Int32, System.Boolean>(Ruby.Builtins.FixnumOps.LessThan),
            });
            
            module.DefineInstanceMethod("<=", Ruby.Runtime.RubyMethodVisibility.Public, new System.Delegate[] {
                new Microsoft.Scripting.Function<System.Int32, System.Int32, System.Boolean>(Ruby.Builtins.FixnumOps.LessThanOrEqual),
            });
            
            module.DefineInstanceMethod("==", Ruby.Runtime.RubyMethodVisibility.Public, new System.Delegate[] {
                new Microsoft.Scripting.Function<System.Int32, System.Int32, System.Boolean>(Ruby.Builtins.FixnumOps.Equal),
                new Microsoft.Scripting.Function<System.Int32, System.Object, System.Boolean>(Ruby.Builtins.FixnumOps.Equal),
            });
            
            module.DefineInstanceMethod("<=>", Ruby.Runtime.RubyMethodVisibility.Public, new System.Delegate[] {
                new Microsoft.Scripting.Function<System.Int32, System.Int32, System.Int32>(Ruby.Builtins.FixnumOps.Compare),
            });
            
            module.DefineInstanceMethod("inspect", Ruby.Runtime.RubyMethodVisibility.Public, new System.Delegate[] {
                new Microsoft.Scripting.Function<System.Int32, Ruby.Builtins.MutableString>(Ruby.Builtins.FixnumOps.Inspect),
            });
            
            module.DefineInstanceMethod("to_i", Ruby.Runtime.RubyMethodVisibility.Public, new System.Delegate[] {
                new Microsoft.Scripting.Function<System.Object, System.Object>(Ruby.Builtins.FixnumOps.ToInteger),
            });
            
            module.DefineInstanceMethod("to_s", Ruby.Runtime.RubyMethodVisibility.Public, new System.Delegate[] {
                new Microsoft.Scripting.Function<System.Object, System.Object>(Ruby.Builtins.FixnumOps.ToString),
            });
            
        }
        
        private void LoadKernel(Ruby.Builtins.RubyModule/*!*/ module) {
            module.DefineInstanceMethod("exit", Ruby.Runtime.RubyMethodVisibility.Private, new System.Delegate[] {
                new System.Action<System.Object>(Ruby.Builtins.Kernel.Exit),
                new Microsoft.Scripting.Action<System.Object, System.Boolean>(Ruby.Builtins.Kernel.Exit),
                new Microsoft.Scripting.Action<System.Object, System.Int32>(Ruby.Builtins.Kernel.Exit),
            });
            
            module.DefineInstanceMethod("exit!", Ruby.Runtime.RubyMethodVisibility.Private, new System.Delegate[] {
                new System.Action<System.Object>(Ruby.Builtins.Kernel.TerminateExecution),
                new Microsoft.Scripting.Action<System.Object, System.Boolean>(Ruby.Builtins.Kernel.TerminateExecution),
                new Microsoft.Scripting.Action<System.Object, System.Int32>(Ruby.Builtins.Kernel.TerminateExecution),
            });
            
            module.DefineInstanceMethod("load", Ruby.Runtime.RubyMethodVisibility.Private, new System.Delegate[] {
                new Microsoft.Scripting.Function<Microsoft.Scripting.CodeContext, System.Object, System.Object, System.Object>(Ruby.Builtins.Kernel.Load),
                new Microsoft.Scripting.Function<Microsoft.Scripting.CodeContext, System.Object, System.Object, System.Object, System.Object>(Ruby.Builtins.Kernel.Load),
            });
            
            module.DefineInstanceMethod("method_missing", Ruby.Runtime.RubyMethodVisibility.Private, new System.Delegate[] {
                new Microsoft.Scripting.Function<Microsoft.Scripting.CodeContext, System.Object, Microsoft.Scripting.SymbolId, System.Object[], System.Object>(Ruby.Builtins.Kernel.MethodMissing),
                new Microsoft.Scripting.Function<Microsoft.Scripting.CodeContext, System.Object, Ruby.Builtins.Proc, Microsoft.Scripting.SymbolId, System.Object[], System.Object>(Ruby.Builtins.Kernel.MethodMissing),
            });
            
            module.DefineInstanceMethod("print", Ruby.Runtime.RubyMethodVisibility.Private, new System.Delegate[] {
                new Microsoft.Scripting.Action<Microsoft.Scripting.CodeContext, System.Object, System.Object[]>(Ruby.Builtins.Kernel.Print),
            });
            
            module.DefineInstanceMethod("puts", Ruby.Runtime.RubyMethodVisibility.Private, new System.Delegate[] {
                new Microsoft.Scripting.Action<System.Object, Ruby.Builtins.MutableString>(Ruby.Builtins.Kernel.PutString),
                new Microsoft.Scripting.Action<Microsoft.Scripting.CodeContext, System.Object, System.Object[]>(Ruby.Builtins.Kernel.PutString),
            });
            
            module.DefineInstanceMethod("raise", Ruby.Runtime.RubyMethodVisibility.Private, new System.Delegate[] {
                new Microsoft.Scripting.Action<Microsoft.Scripting.CodeContext, System.Object>(Ruby.Builtins.Kernel.RaiseException),
                new Microsoft.Scripting.Action<System.Object, Ruby.Builtins.MutableString>(Ruby.Builtins.Kernel.RaiseException),
                new Microsoft.Scripting.Action<Microsoft.Scripting.CodeContext, System.Object, Ruby.Builtins.RubyClass, Ruby.Builtins.MutableString, System.Collections.Generic.List<System.Object>>(Ruby.Builtins.Kernel.RaiseException),
                new Microsoft.Scripting.Action<Microsoft.Scripting.CodeContext, System.Object, System.Object, Ruby.Builtins.MutableString, System.Collections.Generic.List<System.Object>>(Ruby.Builtins.Kernel.RaiseException),
            });
            
            module.DefineInstanceMethod("fail", Ruby.Runtime.RubyMethodVisibility.Private, new System.Delegate[] {
                new Microsoft.Scripting.Action<Microsoft.Scripting.CodeContext, System.Object>(Ruby.Builtins.Kernel.RaiseException),
                new Microsoft.Scripting.Action<System.Object, Ruby.Builtins.MutableString>(Ruby.Builtins.Kernel.RaiseException),
                new Microsoft.Scripting.Action<Microsoft.Scripting.CodeContext, System.Object, Ruby.Builtins.RubyClass, Ruby.Builtins.MutableString, System.Collections.Generic.List<System.Object>>(Ruby.Builtins.Kernel.RaiseException),
                new Microsoft.Scripting.Action<Microsoft.Scripting.CodeContext, System.Object, System.Object, Ruby.Builtins.MutableString, System.Collections.Generic.List<System.Object>>(Ruby.Builtins.Kernel.RaiseException),
            });
            
            module.DefineInstanceMethod("require", Ruby.Runtime.RubyMethodVisibility.Public, new System.Delegate[] {
                new Microsoft.Scripting.Function<Microsoft.Scripting.CodeContext, System.Object, System.String, System.Boolean>(Ruby.Builtins.Kernel.Require),
                new Microsoft.Scripting.Function<Microsoft.Scripting.CodeContext, System.Object, Ruby.Builtins.MutableString, System.Boolean>(Ruby.Builtins.Kernel.Require),
            });
            
            module.DefineClassMethod("exit", Ruby.Runtime.RubyMethodVisibility.Public, new System.Delegate[] {
                new System.Action<System.Object>(Ruby.Builtins.Kernel.Exit),
                new Microsoft.Scripting.Action<System.Object, System.Boolean>(Ruby.Builtins.Kernel.Exit),
                new Microsoft.Scripting.Action<System.Object, System.Int32>(Ruby.Builtins.Kernel.Exit),
            });
            
            module.DefineClassMethod("exit!", Ruby.Runtime.RubyMethodVisibility.Public, new System.Delegate[] {
                new System.Action<System.Object>(Ruby.Builtins.Kernel.TerminateExecution),
                new Microsoft.Scripting.Action<System.Object, System.Boolean>(Ruby.Builtins.Kernel.TerminateExecution),
                new Microsoft.Scripting.Action<System.Object, System.Int32>(Ruby.Builtins.Kernel.TerminateExecution),
            });
            
            module.DefineClassMethod("load", Ruby.Runtime.RubyMethodVisibility.Public, new System.Delegate[] {
                new Microsoft.Scripting.Function<Microsoft.Scripting.CodeContext, System.Object, System.Object, System.Object>(Ruby.Builtins.Kernel.Load),
                new Microsoft.Scripting.Function<Microsoft.Scripting.CodeContext, System.Object, System.Object, System.Object, System.Object>(Ruby.Builtins.Kernel.Load),
            });
            
            module.DefineClassMethod("method_missing", Ruby.Runtime.RubyMethodVisibility.Public, new System.Delegate[] {
                new Microsoft.Scripting.Function<Microsoft.Scripting.CodeContext, System.Object, Microsoft.Scripting.SymbolId, System.Object[], System.Object>(Ruby.Builtins.Kernel.MethodMissing),
                new Microsoft.Scripting.Function<Microsoft.Scripting.CodeContext, System.Object, Ruby.Builtins.Proc, Microsoft.Scripting.SymbolId, System.Object[], System.Object>(Ruby.Builtins.Kernel.MethodMissing),
            });
            
            module.DefineClassMethod("print", Ruby.Runtime.RubyMethodVisibility.Public, new System.Delegate[] {
                new Microsoft.Scripting.Action<Microsoft.Scripting.CodeContext, System.Object, System.Object[]>(Ruby.Builtins.Kernel.Print),
            });
            
            module.DefineClassMethod("puts", Ruby.Runtime.RubyMethodVisibility.Public, new System.Delegate[] {
                new Microsoft.Scripting.Action<System.Object, Ruby.Builtins.MutableString>(Ruby.Builtins.Kernel.PutString),
                new Microsoft.Scripting.Action<Microsoft.Scripting.CodeContext, System.Object, System.Object[]>(Ruby.Builtins.Kernel.PutString),
            });
            
            module.DefineClassMethod("raise", Ruby.Runtime.RubyMethodVisibility.Public, new System.Delegate[] {
                new Microsoft.Scripting.Action<Microsoft.Scripting.CodeContext, System.Object>(Ruby.Builtins.Kernel.RaiseException),
                new Microsoft.Scripting.Action<System.Object, Ruby.Builtins.MutableString>(Ruby.Builtins.Kernel.RaiseException),
                new Microsoft.Scripting.Action<Microsoft.Scripting.CodeContext, System.Object, Ruby.Builtins.RubyClass, Ruby.Builtins.MutableString, System.Collections.Generic.List<System.Object>>(Ruby.Builtins.Kernel.RaiseException),
                new Microsoft.Scripting.Action<Microsoft.Scripting.CodeContext, System.Object, System.Object, Ruby.Builtins.MutableString, System.Collections.Generic.List<System.Object>>(Ruby.Builtins.Kernel.RaiseException),
            });
            
            module.DefineClassMethod("fail", Ruby.Runtime.RubyMethodVisibility.Public, new System.Delegate[] {
                new Microsoft.Scripting.Action<Microsoft.Scripting.CodeContext, System.Object>(Ruby.Builtins.Kernel.RaiseException),
                new Microsoft.Scripting.Action<System.Object, Ruby.Builtins.MutableString>(Ruby.Builtins.Kernel.RaiseException),
                new Microsoft.Scripting.Action<Microsoft.Scripting.CodeContext, System.Object, Ruby.Builtins.RubyClass, Ruby.Builtins.MutableString, System.Collections.Generic.List<System.Object>>(Ruby.Builtins.Kernel.RaiseException),
                new Microsoft.Scripting.Action<Microsoft.Scripting.CodeContext, System.Object, System.Object, Ruby.Builtins.MutableString, System.Collections.Generic.List<System.Object>>(Ruby.Builtins.Kernel.RaiseException),
            });
            
            module.DefineClassMethod("require", Ruby.Runtime.RubyMethodVisibility.Public, new System.Delegate[] {
                new Microsoft.Scripting.Function<Microsoft.Scripting.CodeContext, System.Object, System.String, System.Boolean>(Ruby.Builtins.Kernel.Require),
                new Microsoft.Scripting.Function<Microsoft.Scripting.CodeContext, System.Object, Ruby.Builtins.MutableString, System.Boolean>(Ruby.Builtins.Kernel.Require),
            });
            
        }
        
        private void LoadNilClass(Ruby.Builtins.RubyModule/*!*/ module) {
            module.DefineInstanceMethod("&", Ruby.Runtime.RubyMethodVisibility.Public, new System.Delegate[] {
                new Microsoft.Scripting.Function<System.Object, System.Object, System.Boolean>(Ruby.Builtins.NilClassOps.And),
            });
            
            module.DefineInstanceMethod("^", Ruby.Runtime.RubyMethodVisibility.Public, new System.Delegate[] {
                new Microsoft.Scripting.Function<System.Object, System.Object, System.Boolean>(Ruby.Builtins.NilClassOps.Xor),
                new Microsoft.Scripting.Function<System.Object, System.Boolean, System.Boolean>(Ruby.Builtins.NilClassOps.Xor),
            });
            
            module.DefineInstanceMethod("|", Ruby.Runtime.RubyMethodVisibility.Public, new System.Delegate[] {
                new Microsoft.Scripting.Function<System.Object, System.Object, System.Boolean>(Ruby.Builtins.NilClassOps.Or),
                new Microsoft.Scripting.Function<System.Object, System.Boolean, System.Boolean>(Ruby.Builtins.NilClassOps.Or),
            });
            
            module.DefineInstanceMethod("nil?", Ruby.Runtime.RubyMethodVisibility.Public, new System.Delegate[] {
                new Microsoft.Scripting.Function<System.Object, System.Boolean>(Ruby.Builtins.NilClassOps.IsNil),
            });
            
            module.DefineInstanceMethod("to_a", Ruby.Runtime.RubyMethodVisibility.Public, new System.Delegate[] {
                new Microsoft.Scripting.Function<System.Object, System.Collections.Generic.List<System.Object>>(Ruby.Builtins.NilClassOps.ToArray),
            });
            
            module.DefineInstanceMethod("to_f", Ruby.Runtime.RubyMethodVisibility.Public, new System.Delegate[] {
                new Microsoft.Scripting.Function<System.Object, System.Double>(Ruby.Builtins.NilClassOps.ToDouble),
            });
            
            module.DefineInstanceMethod("to_i", Ruby.Runtime.RubyMethodVisibility.Public, new System.Delegate[] {
                new Microsoft.Scripting.Function<System.Object, System.Int32>(Ruby.Builtins.NilClassOps.ToInteger),
            });
            
            module.DefineInstanceMethod("inspect", Ruby.Runtime.RubyMethodVisibility.Public, new System.Delegate[] {
                new Microsoft.Scripting.Function<System.Object, Ruby.Builtins.MutableString>(Ruby.Builtins.NilClassOps.Inspect),
            });
            
            module.DefineInstanceMethod("to_s", Ruby.Runtime.RubyMethodVisibility.Public, new System.Delegate[] {
                new Microsoft.Scripting.Function<System.Object, Ruby.Builtins.MutableString>(Ruby.Builtins.NilClassOps.ToString),
            });
            
        }
        
        private void LoadProc(Ruby.Builtins.RubyModule/*!*/ module) {
            module.DefineInstanceMethod("[]", Ruby.Runtime.RubyMethodVisibility.Public, new System.Delegate[] {
                new Microsoft.Scripting.Function<Ruby.Builtins.Proc, System.Object[], System.Object>(Ruby.Builtins.Proc.Call),
            });
            
            module.DefineInstanceMethod("call", Ruby.Runtime.RubyMethodVisibility.Public, new System.Delegate[] {
                new Microsoft.Scripting.Function<Ruby.Builtins.Proc, System.Object[], System.Object>(Ruby.Builtins.Proc.Call),
            });
            
        }
        
        private void LoadRange(Ruby.Builtins.RubyModule/*!*/ module) {
            module.DefineInstanceMethod("begin", Ruby.Runtime.RubyMethodVisibility.Public, new System.Delegate[] {
                new Microsoft.Scripting.Function<Ruby.Builtins.Range, System.Object>(Ruby.Builtins.Range.Begin),
            });
            
            module.DefineInstanceMethod("first", Ruby.Runtime.RubyMethodVisibility.Public, new System.Delegate[] {
                new Microsoft.Scripting.Function<Ruby.Builtins.Range, System.Object>(Ruby.Builtins.Range.First),
            });
            
            module.DefineInstanceMethod("end", Ruby.Runtime.RubyMethodVisibility.Public, new System.Delegate[] {
                new Microsoft.Scripting.Function<Ruby.Builtins.Range, System.Object>(Ruby.Builtins.Range.End),
            });
            
            module.DefineInstanceMethod("last", Ruby.Runtime.RubyMethodVisibility.Public, new System.Delegate[] {
                new Microsoft.Scripting.Function<Ruby.Builtins.Range, System.Object>(Ruby.Builtins.Range.Last),
            });
            
            module.DefineInstanceMethod("exclude_end?", Ruby.Runtime.RubyMethodVisibility.Public, new System.Delegate[] {
                new Microsoft.Scripting.Function<Ruby.Builtins.Range, System.Boolean>(Ruby.Builtins.Range.ExcludeEnd),
            });
            
            module.DefineInstanceMethod("inspect", Ruby.Runtime.RubyMethodVisibility.Public, new System.Delegate[] {
                new Microsoft.Scripting.Function<Ruby.Builtins.Range, Ruby.Builtins.MutableString>(Ruby.Builtins.Range.ToS),
            });
            
            module.DefineInstanceMethod("to_s", Ruby.Runtime.RubyMethodVisibility.Public, new System.Delegate[] {
                new Microsoft.Scripting.Function<Ruby.Builtins.Range, Ruby.Builtins.MutableString>(Ruby.Builtins.Range.ToS),
            });
            
            module.DefineInstanceMethod("==", Ruby.Runtime.RubyMethodVisibility.Public, new System.Delegate[] {
                new Microsoft.Scripting.Function<Ruby.Builtins.Range, System.Object, System.Boolean>(Ruby.Builtins.Range.Equals),
                new Microsoft.Scripting.Function<Ruby.Builtins.Range, Ruby.Builtins.Range, System.Boolean>(Ruby.Builtins.Range.Equals),
            });
            
        }
        
        private void LoadRegexp(Ruby.Builtins.RubyModule/*!*/ module) {
            module.DefineInstanceMethod("=~", Ruby.Runtime.RubyMethodVisibility.Public, new System.Delegate[] {
                new Microsoft.Scripting.Function<System.Text.RegularExpressions.Regex, System.Object, System.Object>(Ruby.Builtins.Regexp.Match),
            });
            
            module.DefineInstanceMethod("source", Ruby.Runtime.RubyMethodVisibility.Public, new System.Delegate[] {
                new Microsoft.Scripting.Function<System.Text.RegularExpressions.Regex, Ruby.Builtins.MutableString>(Ruby.Builtins.Regexp.Source),
            });
            
        }
        
        private void LoadString(Ruby.Builtins.RubyModule/*!*/ module) {
            module.DefineInstanceMethod("to_str", Ruby.Runtime.RubyMethodVisibility.Public, new System.Delegate[] {
                new Microsoft.Scripting.Function<System.String, Ruby.Builtins.MutableString>(Ruby.Builtins.StringOps.ToStr),
            });
            
            module.DefineInstanceMethod("inspect", Ruby.Runtime.RubyMethodVisibility.Public, new System.Delegate[] {
                new Microsoft.Scripting.Function<System.String, Ruby.Builtins.MutableString>(Ruby.Builtins.StringOps.ToStr),
            });
            
        }
        
        private void LoadSymbol(Ruby.Builtins.RubyModule/*!*/ module) {
            module.DefineInstanceMethod("to_s", Ruby.Runtime.RubyMethodVisibility.Public, new System.Delegate[] {
                new Microsoft.Scripting.Function<Microsoft.Scripting.SymbolId, Ruby.Builtins.MutableString>(Ruby.Builtins.SymbolOps.ToString),
            });
            
            module.DefineInstanceMethod("id2name", Ruby.Runtime.RubyMethodVisibility.Public, new System.Delegate[] {
                new Microsoft.Scripting.Function<Microsoft.Scripting.SymbolId, Ruby.Builtins.MutableString>(Ruby.Builtins.SymbolOps.ToString),
            });
            
            module.DefineInstanceMethod("inspect", Ruby.Runtime.RubyMethodVisibility.Public, new System.Delegate[] {
                new Microsoft.Scripting.Function<Microsoft.Scripting.SymbolId, Ruby.Builtins.MutableString>(Ruby.Builtins.SymbolOps.Inspect),
            });
            
            module.DefineInstanceMethod("to_i", Ruby.Runtime.RubyMethodVisibility.Public, new System.Delegate[] {
                new Microsoft.Scripting.Function<Microsoft.Scripting.SymbolId, System.Int32>(Ruby.Builtins.SymbolOps.ToInteger),
            });
            
            module.DefineInstanceMethod("to_int", Ruby.Runtime.RubyMethodVisibility.Public, new System.Delegate[] {
                new Microsoft.Scripting.Function<Microsoft.Scripting.SymbolId, System.Int32>(Ruby.Builtins.SymbolOps.ToInteger),
            });
            
            module.DefineInstanceMethod("to_sym", Ruby.Runtime.RubyMethodVisibility.Public, new System.Delegate[] {
                new Microsoft.Scripting.Function<Microsoft.Scripting.SymbolId, Microsoft.Scripting.SymbolId>(Ruby.Builtins.SymbolOps.ToSymbol),
            });
            
            module.DefineClassMethod("all_symbols", Ruby.Runtime.RubyMethodVisibility.Public, new System.Delegate[] {
                new Microsoft.Scripting.Function<System.Object, System.Collections.Generic.List<System.Object>>(Ruby.Builtins.SymbolOps.GetAllSymbols),
            });
            
        }
        
        private void LoadUnboundMethod(Ruby.Builtins.RubyModule/*!*/ module) {
        }
        
    }
}
