/* ****************************************************************************
 *
 * Copyright (c) Microsoft Corporation. 
 *
 * This source code is subject to terms and conditions of the Microsoft Permissive License. A 
 * copy of the license can be found in the License.html file at the root of this distribution. If 
 * you cannot locate the  Microsoft Permissive License, please send an email to 
 * ironruby@microsoft.com. By using this source code in any fashion, you are agreeing to be bound 
 * by the terms of the Microsoft Permissive License.
 *
 * You must not remove this notice, or any other, from this software.
 *
 *
 * ***************************************************************************/

using System;
using System.Collections.Generic;
using System.Text;
using Ruby.Runtime;
using Microsoft.Scripting;

namespace Ruby.Builtins {

    [RubyClass]
    public class Method : Object {
        private readonly RubyMethodInfo/*!*/ _info;

        /// <summary>
        /// Note, that <c>instance</c> could be null - a method can be bound to the nil singleton.
        /// </summary>
        internal Method(object instance, RubyMethodInfo/*!*/ info) {
            Utils.Assert.NotNull(info);

            _info = info;
        }
        
        #region Public Instance Methods
        
        //==
        //[]
        //arity
        //call
        //clone
        //inspect
        //to_proc
        //to_s
        //unbind

        #endregion
    }
}
