/* ****************************************************************************
 *
 * Copyright (c) Microsoft Corporation. 
 *
 * This source code is subject to terms and conditions of the Microsoft Permissive License. A 
 * copy of the license can be found in the License.html file at the root of this distribution. If 
 * you cannot locate the  Microsoft Permissive License, please send an email to 
 * ironruby@microsoft.com. By using this source code in any fashion, you are agreeing to be bound 
 * by the terms of the Microsoft Permissive License.
 *
 * You must not remove this notice, or any other, from this software.
 *
 *
 * ***************************************************************************/

using System;
using System.Collections.Generic;
using System.Text;
using System.Text.RegularExpressions;
using Ruby.Runtime;

namespace Ruby.Builtins {
    [RubyClass, Includes(typeof(Enumerable))]
    public class Regexp {
        //declared private instance methods:
        //  initialize
        //  initialize_copy
        //declared protected instance methods:
        //declared public instance methods:
        //  ==
        //  ===
        //  casefold?
        //  eql?
        //  hash
        //  inspect
        //  kcode
        //  match
        //  options
        //  taguri
        //  taguri=
        //  to_s
        //  ~
        //declared singleton methods:
        //  compile
        //  escape
        //  last_match
        //  quote
        //  union
        //declared class variables:
        //declared constants:
        //  EXTENDED
        //  IGNORECASE
        //  MULTILINE

        [RubyMethodAttribute("=~", RubyMethodAttributes.PublicInstance)]
        public static object Match(Regex self, object str) {
            Match match = self.Match(str.ToString());
            return match.Success ? (object)match.Index : null;
        }

        [RubyMethodAttribute("source", RubyMethodAttributes.PublicInstance)]
        public static MutableString Source(Regex regex) {
            return new MutableString(regex.ToString());
        }
    }
}
