/* ****************************************************************************
 *
 * Copyright (c) Microsoft Corporation. 
 *
 * This source code is subject to terms and conditions of the Microsoft Permissive License. A 
 * copy of the license can be found in the License.html file at the root of this distribution. If 
 * you cannot locate the  Microsoft Permissive License, please send an email to 
 * ironruby@microsoft.com. By using this source code in any fashion, you are agreeing to be bound 
 * by the terms of the Microsoft Permissive License.
 *
 * You must not remove this notice, or any other, from this software.
 *
 *
 * ***************************************************************************/

using System;
using System.Collections.Generic;
using System.IO;
using System.Text;
using System.Text.RegularExpressions;
using Ruby.Runtime;
using Ruby.Compiler;
using Microsoft.Scripting;
using Microsoft.Scripting.Actions;
using MSA = Microsoft.Scripting.Ast;

namespace Ruby.Builtins {
    // Extension methods for System.String
    [RubyExtensionClass("String", typeof(string)), Includes(typeof(Enumerable)), Includes(typeof(Comparable))]
    public static class StringOps { 

        [RubyMethodAttribute("inspect", RubyMethodAttributes.PublicInstance)]
        [RubyMethodAttribute("to_str", RubyMethodAttributes.PublicInstance)]
        public static MutableString ToStr(string str) {
            return new MutableString(str);
        }
    }
}
