/* ****************************************************************************
 *
 * Copyright (c) Microsoft Corporation. 
 *
 * This source code is subject to terms and conditions of the Microsoft Permissive License. A 
 * copy of the license can be found in the License.html file at the root of this distribution. If 
 * you cannot locate the  Microsoft Permissive License, please send an email to 
 * ironruby@microsoft.com. By using this source code in any fashion, you are agreeing to be bound 
 * by the terms of the Microsoft Permissive License.
 *
 * You must not remove this notice, or any other, from this software.
 *
 *
 * ***************************************************************************/

using System;
using System.Collections.Generic;
using System.Text;
using System.Threading;
using Ruby.Runtime;
using Microsoft.Scripting;
using Microsoft.Scripting.Actions;
using Microsoft.Scripting.Ast;

namespace Ruby.Builtins {
    [RubyExtensionClass("Thread", typeof(Thread), Inherits = typeof(object))]
    public static class ThreadOps {
//  declared private instance methods:
//    initialize
//  declared protected instance methods:
//  declared public instance methods:
//    []
//    []=
//    abort_on_exception
//    abort_on_exception=
//    alive?
//    exit
//    group
//    inspect

        [RubyMethod("join", RubyMethodAttributes.PublicInstance)]
        public static Thread/*!*/ Join(Thread/*!*/ self) {
            self.Join();
            return self;
        }

//    key?
//    keys
//    kill
//    priority
//    priority=
//    raise
//    run
//    safe_level
//    status
//    stop?
//    terminate
//    value
//    wakeup

//  declared singleton methods:
//    abort_on_exception
//    abort_on_exception=
//    critical
//    critical=
//    current
//    exclusive
//    exit
//    fork
//    kill
//    list
//    main

        [RubyMethod("new", RubyMethodAttributes.PublicSingleton)]
        public static Thread/*!*/ CreateThread(CodeContext/*!*/ context, object self, Proc/*!*/ startRoutine, [NotNull]params object[]/*!*/ args) {
            // TODO: args
            Thread result = new Thread(new ThreadStart(delegate() {
                FastDynamicSite<Proc, BlockReturnReasonHolder, List<object>, object>.
                    Create(context, CallAction.Make(new ArgumentInfo(ArgumentKind.Simple), new ArgumentInfo(ArgumentKind.Simple), new ArgumentInfo(ArgumentKind.List))).
                        Invoke(startRoutine, new BlockReturnReasonHolder(), new List<object>(args));
            }));
            result.Start();
            return result;
        }

//    pass
//    start
//    stop
    }
}
