/* ****************************************************************************
 *
 * Copyright (c) Microsoft Corporation. 
 *
 * This source code is subject to terms and conditions of the Microsoft Permissive License. A 
 * copy of the license can be found in the License.html file at the root of this distribution. If 
 * you cannot locate the  Microsoft Permissive License, please send an email to 
 * ironruby@microsoft.com. By using this source code in any fashion, you are agreeing to be bound 
 * by the terms of the Microsoft Permissive License.
 *
 * You must not remove this notice, or any other, from this software.
 *
 *
 * ***************************************************************************/
using System;
using System.Diagnostics;
using Microsoft.Scripting;
using Ruby.Runtime;

namespace Ruby.Builtins {
    
    [RubyClass]
    public class TrueClass : Object {
        #region Public Instance Methods

        [RubyMethodAttribute("to_s")]
        [RubyMethodAttribute("inspect")]
        public static MutableString/*!*/ ToString(bool self) {
            Debug.Assert(self == true);
            return new MutableString("true"); 
        }

        [RubyMethodAttribute("&")]
        public static bool And(bool self, object obj) {
            Debug.Assert(self == true);
            return obj != null;
        }

        [RubyMethodAttribute("&")]
        public static bool And(bool self, bool obj) {
            Debug.Assert(self == true);
            return obj;
        }

        [RubyMethodAttribute("^")]
        public static bool Xor(bool self, object obj) {
            Debug.Assert(self == true);
            return obj == null;
        }

        [RubyMethodAttribute("^")]
        public static bool Xor(bool self, bool obj) {
            Debug.Assert(self == true);
            return !obj;
        }

        [RubyMethodAttribute("|")]
        public static bool Or(bool self, object obj) {
            Debug.Assert(self == true);
            return true;
        }

        #endregion
    }
}
