/* ****************************************************************************
 *
 * Copyright (c) Microsoft Corporation. 
 *
 * This source code is subject to terms and conditions of the Microsoft Permissive License. A 
 * copy of the license can be found in the License.html file at the root of this distribution. If 
 * you cannot locate the  Microsoft Permissive License, please send an email to 
 * ironruby@microsoft.com. By using this source code in any fashion, you are agreeing to be bound 
 * by the terms of the Microsoft Permissive License.
 *
 * You must not remove this notice, or any other, from this software.
 *
 *
 * ***************************************************************************/

using System;
using System.Collections.Generic;
using System.Text;
using Ruby.Runtime;
using Microsoft.Scripting;
using Ruby.Compiler;
using System.Diagnostics;
using Ruby.Hosting;
using System.IO;

namespace Ruby.Builtins {

    /// <summary>
    /// This module is mixed automatically into each XAML page.
    /// </summary>
    public static class XamlPage {
        #region Private Instance Methods

        [RubyMethodAttribute("method_missing", RubyMethodAttributes.PrivateInstance)]
        public static object MethodMissing(CodeContext/*!*/ context, object self, object/*!*/ name) {
            Debug.Assert(name is string);

            object value;
            if (!ScriptDomainManager.CurrentManager.Host.TryGetVariable(RubyEngine.CurrentEngine, SymbolTable.StringToId((string)name), out value)) {
                throw new MissingMemberException(String.Format("Unknown XAML element '{0}'", name));
            }
            return value;
        }

        #endregion

        internal static RubyClass/*!*/ InitializeScriptModule(ScriptModule/*!*/ module) {
            Utils.Assert.NotNull(module);

            // obsolete:
            //string className = Path.GetFileNameWithoutExtension(module.FileName);
            //Debug.Assert(!String.IsNullOrEmpty(className));

            //if (Char.IsLower(className[0])) {
            //    className = Char.ToUpper(className[0]) + className.Substring(1);
            //}

            //CodeContext context = RubyEngine.CurrentEngine.DefaultContext;

            //DynamicMixin xamlPagesNamespace = RubyOps.DefineModuleInternal(context, TypeCache.Object, "XamlPages", null);
            //DynamicMixin xamlPageMixin = RubyOps.DefineModuleInternal(context, TypeCache.Object, "XamlPage", null);
            //DynamicType xamlPageClass = (DynamicType)RubyOps.DefineModuleInternal(context, xamlPagesNamespace, className, TypeCache.Object);

            //// MyXamlPage <# XamlPage
            //RubyOps.SetMixins(context, xamlPageClass, new DynamicMixin[] { xamlPageMixin });

            //// methods (TODO: auto):
            //RubyOps.DefineMethodInternal(context, xamlPageMixin, null, "method_missing", new CallTargetWithContext2(XamlPage.MethodMissing), false);

            //return xamlPageClass;
            throw new NotImplementedError();
        }
    }
}
