/* ****************************************************************************
 *
 * Copyright (c) Microsoft Corporation. 
 *
 * This source code is subject to terms and conditions of the Microsoft Permissive License. A 
 * copy of the license can be found in the License.html file at the root of this distribution. If 
 * you cannot locate the  Microsoft Permissive License, please send an email to 
 * ironruby@microsoft.com. By using this source code in any fashion, you are agreeing to be bound 
 * by the terms of the Microsoft Permissive License.
 *
 * You must not remove this notice, or any other, from this software.
 *
 *
 * ***************************************************************************/

using System;
using System.Collections.Generic;
using System.Text;

using MSA = Microsoft.Scripting.Ast;
using Microsoft.Scripting;

namespace Ruby.Compiler.AST {
    public class WhenClause : Node {
        //	when comparison
        //		body
        //	next

        private Arguments/*!*/ _comparison;
        private List<Statement> _body;	// optional

        public WhenClause(Arguments/*!*/ comparison, List<Statement> body, SourceSpan location)
            : base(location) {
            Utils.Assert.NotNull(comparison);

            _comparison = comparison;
            _body = body;
        }
    }
}
