/* ****************************************************************************
 *
 * Copyright (c) Microsoft Corporation. 
 *
 * This source code is subject to terms and conditions of the Microsoft Permissive License. A 
 * copy of the license can be found in the License.html file at the root of this distribution. If 
 * you cannot locate the  Microsoft Permissive License, please send an email to 
 * ironruby@microsoft.com. By using this source code in any fashion, you are agreeing to be bound 
 * by the terms of the Microsoft Permissive License.
 *
 * You must not remove this notice, or any other, from this software.
 *
 *
 * ***************************************************************************/

using System.Collections.Generic;
using System.Text;
using Microsoft.Scripting;


namespace Ruby.Compiler.AST {

    public class RescueStatement : Statement {
        //	expr rescue rescue 

        private Statement _expr;
        private Statement _rescue;

        public RescueStatement(Statement expr, Statement rescue, SourceSpan location)
            : base(location) {
            this._expr = expr;
            this._rescue = rescue;
        }
    }

    public class RescueExpression : Expression {
        //	expr rescue rescue 

        private Expression _expr;
        private Expression _rescue;

        public RescueExpression(Expression expr, Expression rescue, SourceSpan location)
            : base(location) {
            this._expr = expr;
            this._rescue = rescue;
        }
    }
}
