/* ****************************************************************************
 *
 * Copyright (c) Microsoft Corporation. 
 *
 * This source code is subject to terms and conditions of the Microsoft Permissive License. A 
 * copy of the license can be found in the License.html file at the root of this distribution. If 
 * you cannot locate the  Microsoft Permissive License, please send an email to 
 * ironruby@microsoft.com. By using this source code in any fashion, you are agreeing to be bound 
 * by the terms of the Microsoft Permissive License.
 *
 * You must not remove this notice, or any other, from this software.
 *
 *
 * ***************************************************************************/

using System;
using System.Collections.Generic;
using System.Diagnostics;
using System.Text;

using Microsoft.Scripting;
using MSA = Microsoft.Scripting.Ast;
using Ast = Microsoft.Scripting.Ast.Ast;
using Ruby.Runtime;

namespace Ruby.Compiler.AST {

    /// <summary>
    /// TODO: unify with OrExpression (?)
    /// </summary>
    public class AndExpression : Expression {
        private readonly Expression/*!*/ _left;
        private readonly Expression/*!*/ _right;

        public AndExpression(Expression/*!*/ left, Expression/*!*/ right, SourceSpan location) 
            : base(location) {
            Utils.Assert.NotNull(left, right);

            _left = left;
            _right = right;
        }

        public override MSA.Expression/*!*/ TransformRead(AstGenerator/*!*/ gen) {
            return Ast.And(Location, _left.TransformRead(gen), _right.TransformRead(gen));
        }
    }
}
