/* ****************************************************************************
 *
 * Copyright (c) Microsoft Corporation. 
 *
 * This source code is subject to terms and conditions of the Microsoft Permissive License. A 
 * copy of the license can be found in the License.html file at the root of this distribution. If 
 * you cannot locate the  Microsoft Permissive License, please send an email to 
 * ironruby@microsoft.com. By using this source code in any fashion, you are agreeing to be bound 
 * by the terms of the Microsoft Permissive License.
 *
 * You must not remove this notice, or any other, from this software.
 *
 *
 * ***************************************************************************/

using System;
using System.Collections.Generic;
using System.Text;
using System.Diagnostics;
using Microsoft.Scripting;

namespace Ruby.Compiler.AST {
    
    /// <summary>
    /// lhs = rhs
    /// lhs op= rhs
    /// </summary>
    public abstract class AssignmentExpression : Expression {
        // "&" "|", null, etc
        private SymbolId _operation; // TODO

        public override string NodeName { get { return "assignment"; } }

        public SymbolId Operation {
            get { return _operation; }
            set { _operation = value; }
        }

        public AssignmentExpression(SymbolId operation, SourceSpan location)
            : base(location) {

            _operation = operation;
        }
    }
}
