/* ****************************************************************************
 *
 * Copyright (c) Microsoft Corporation. 
 *
 * This source code is subject to terms and conditions of the Microsoft Permissive License. A 
 * copy of the license can be found in the License.html file at the root of this distribution. If 
 * you cannot locate the  Microsoft Permissive License, please send an email to 
 * ironruby@microsoft.com. By using this source code in any fashion, you are agreeing to be bound 
 * by the terms of the Microsoft Permissive License.
 *
 * You must not remove this notice, or any other, from this software.
 *
 *
 * ***************************************************************************/

using System;
using System.Collections.Generic;
using System.Text;

using MSA = Microsoft.Scripting.Ast;
using Microsoft.Scripting;

namespace Ruby.Compiler.AST {
    public abstract class CallExpression : Expression {
        private Arguments _args;

        public Arguments Arguments {
            get { return _args; }
        }

        protected CallExpression(Arguments args, SourceSpan location)
            : base(location) {

            Utils.Assert.NotNull(args);
            
            _args = args;
        }
    }
}
