/* ****************************************************************************
 *
 * Copyright (c) Microsoft Corporation. 
 *
 * This source code is subject to terms and conditions of the Microsoft Permissive License. A 
 * copy of the license can be found in the License.html file at the root of this distribution. If 
 * you cannot locate the  Microsoft Permissive License, please send an email to 
 * ironruby@microsoft.com. By using this source code in any fashion, you are agreeing to be bound 
 * by the terms of the Microsoft Permissive License.
 *
 * You must not remove this notice, or any other, from this software.
 *
 *
 * ***************************************************************************/

using System;
using System.Collections.Generic;
using System.Text;
using Microsoft.Scripting;

namespace Ruby.Compiler.AST {
    public class CaseExpression : Expression {
        
        //	case value 
        //		when args: statements
        //      ...
        //      when args: statements
        //  else
        //      statements
        //	end

        // equivalent to
        // value == null:
        //   if <expr> then <stmts> elseif <expr> then <stmts> else <stmts> end
        // value != null:
        //   if <value> === <expr> then <stmts> elseif <value> === <expr> then <stmts> else <stmts> end

        private Expression _value;    
        private List<WhenClause> _whenClauses;
        private ElseIfClause _elseClause;
        
        public CaseExpression(Expression value, List<WhenClause> whenClauses, ElseIfClause elseClause, SourceSpan location)
            : base(location) {

            _value = value;
            _whenClauses = whenClauses;
            _elseClause = elseClause;
        }
    }
}
