/* ****************************************************************************
 *
 * Copyright (c) Microsoft Corporation. 
 *
 * This source code is subject to terms and conditions of the Microsoft Permissive License. A 
 * copy of the license can be found in the License.html file at the root of this distribution. If 
 * you cannot locate the  Microsoft Permissive License, please send an email to 
 * ironruby@microsoft.com. By using this source code in any fashion, you are agreeing to be bound 
 * by the terms of the Microsoft Permissive License.
 *
 * You must not remove this notice, or any other, from this software.
 *
 *
 * ***************************************************************************/

using System;
using System.Collections.Generic;
using System.Text;
using Microsoft.Scripting;
using System.Diagnostics;

namespace Ruby.Compiler.AST {
    public abstract class DeclarationExpression : Expression {
        private readonly LexicalScope/*!*/ _definedScope;
        private readonly Body/*!*/ _body;

        public LexicalScope/*!*/ DefinedScope {
            get {
                return _definedScope;
            }
        }

        public Body/*!*/ Body {
            get {
                return _body;
            }
        }

        protected DeclarationExpression(LexicalScope/*!*/ definedScope, Body/*!*/ body, SourceSpan location) 
            : base(location) {
            Utils.Assert.NotNull(definedScope, body);

            _definedScope = definedScope;
            _body = body;
        }
    }
}
