/* ****************************************************************************
 *
 * Copyright (c) Microsoft Corporation. 
 *
 * This source code is subject to terms and conditions of the Microsoft Permissive License. A 
 * copy of the license can be found in the License.html file at the root of this distribution. If 
 * you cannot locate the  Microsoft Permissive License, please send an email to 
 * ironruby@microsoft.com. By using this source code in any fashion, you are agreeing to be bound 
 * by the terms of the Microsoft Permissive License.
 *
 * You must not remove this notice, or any other, from this software.
 *
 *
 * ***************************************************************************/

using System;
using System.Collections.Generic;
using System.Diagnostics;
using System.Text;

using Microsoft.Scripting;
using MSA = Microsoft.Scripting.Ast;
using Ruby.Runtime;

namespace Ruby.Compiler.AST {

    public class NotExpression : Expression {
        private readonly Expression/*!*/ _expression;

        public NotExpression(Expression/*!*/ expression, SourceSpan location) 
            : base(location) {
            Utils.Assert.NotNull(expression);

            _expression = expression;
        }

        public override MSA.Expression/*!*/ TransformRead(AstGenerator/*!*/ gen) {
            return gen.OpCall("IsFalse", new MSA.Expression[] { _expression.TransformRead(gen) }); 
        }
    }
}
