/* ****************************************************************************
 *
 * Copyright (c) Microsoft Corporation. 
 *
 * This source code is subject to terms and conditions of the Microsoft Permissive License. A 
 * copy of the license can be found in the License.html file at the root of this distribution. If 
 * you cannot locate the  Microsoft Permissive License, please send an email to 
 * ironruby@microsoft.com. By using this source code in any fashion, you are agreeing to be bound 
 * by the terms of the Microsoft Permissive License.
 *
 * You must not remove this notice, or any other, from this software.
 *
 *
 * ***************************************************************************/

using System;
using System.Collections.Generic;
using System.Text;

using MSA = Microsoft.Scripting.Ast;
using Ast = Microsoft.Scripting.Ast.Ast;
using Microsoft.Scripting;
using Ruby.Runtime;

namespace Ruby.Compiler.AST {

    /// <summary>
    /// self
    /// </summary>
    public sealed class SelfReference : Expression {

        public override string NodeName { get { return "self"; } }

        public SelfReference(SourceSpan location)
            : base(location) {
        }

        public override MSA.Expression/*!*/ TransformRead(AstGenerator/*!*/ gen) {
            return gen.MakeSelfRead();
        }

        internal static MSA.Expression/*!*/ MakeContextSelf(AstGenerator/*!*/ gen) {
            return gen.OpCall("GetSelf", new MSA.Expression[] { Ast.CodeContext() });
        }
    }
}
