/* ****************************************************************************
 *
 * Copyright (c) Microsoft Corporation. 
 *
 * This source code is subject to terms and conditions of the Microsoft Permissive License. A 
 * copy of the license can be found in the License.html file at the root of this distribution. If 
 * you cannot locate the  Microsoft Permissive License, please send an email to 
 * ironruby@microsoft.com. By using this source code in any fashion, you are agreeing to be bound 
 * by the terms of the Microsoft Permissive License.
 *
 * You must not remove this notice, or any other, from this software.
 *
 *
 * ***************************************************************************/

using System;
using System.Collections.Generic;
using System.Text;
using Microsoft.Scripting;

namespace Ruby.Compiler.AST {
    
    /// <summary>
    /// super(args)
    /// </summary>
    public class SuperCall : CallExpression {
        private LexicalScope _scope;

        public override string NodeName { get { return "super"; } }

        public SuperCall(LexicalScope/*!*/ scope, Arguments/*!*/ args, SourceSpan location)
            : base(args, location) {
            Utils.Assert.NotNull(scope, args);

            _scope = scope;
        }
    }
}
