/* ****************************************************************************
 *
 * Copyright (c) Microsoft Corporation. 
 *
 * This source code is subject to terms and conditions of the Microsoft Permissive License. A 
 * copy of the license can be found in the License.html file at the root of this distribution. If 
 * you cannot locate the  Microsoft Permissive License, please send an email to 
 * ironruby@microsoft.com. By using this source code in any fashion, you are agreeing to be bound 
 * by the terms of the Microsoft Permissive License.
 *
 * You must not remove this notice, or any other, from this software.
 *
 *
 * ***************************************************************************/

using System;
using System.Collections.Generic;
using System.Text;
using Microsoft.Scripting;
using MSA = Microsoft.Scripting.Ast;
using Ast = Microsoft.Scripting.Ast.Ast;
using Ruby.Runtime;

namespace Ruby.Compiler.AST {
    public class AttributeAccess : LeftValue {
        // scope::vid =

        private Expression/*!*/ _qualifier;
        private SymbolId _name;

        public override string NodeName { get { return "assignment"; } }

        public AttributeAccess(Expression/*!*/ qualifier, SymbolId name, SourceSpan location)
            : base(location) {
            Utils.Assert.NotNull(qualifier);

            _name = SymbolTable.StringToId(SymbolTable.IdToString(name) + "=");
            _qualifier = qualifier;
        }

        public override MSA.Expression/*!*/ TransformWrite(AstGenerator/*!*/ gen, MSA.Expression/*!*/ rightValue) {
            return MethodCall.TransformRead(gen, _name, _qualifier, null, rightValue);
        }
    }
}
