/* ****************************************************************************
 *
 * Copyright (c) Microsoft Corporation. 
 *
 * This source code is subject to terms and conditions of the Microsoft Permissive License. A 
 * copy of the license can be found in the License.html file at the root of this distribution. If 
 * you cannot locate the  Microsoft Permissive License, please send an email to 
 * ironruby@microsoft.com. By using this source code in any fashion, you are agreeing to be bound 
 * by the terms of the Microsoft Permissive License.
 *
 * You must not remove this notice, or any other, from this software.
 *
 *
 * ***************************************************************************/

using System;
using System.Collections.Generic;
using System.Text;
using Microsoft.Scripting;
using MSA = Microsoft.Scripting.Ast;

namespace Ruby.Compiler.AST {
    public abstract class LeftValue : Expression {
        internal static readonly List<LeftValue>/*!*/ EmptyList = new List<LeftValue>();

        public LeftValue(SourceSpan location)
            : base(location) {
        }

        public abstract MSA.Expression/*!*/ TransformWrite(AstGenerator/*!*/ gen, MSA.Expression/*!*/ rightValue);

        internal virtual List<LeftValue>/*!*/ ToList() {
            List<LeftValue> result = new List<LeftValue>();
            result.Add(this);
            return result;
        }
    }
}
