/* ****************************************************************************
 *
 * Copyright (c) Microsoft Corporation. 
 *
 * This source code is subject to terms and conditions of the Microsoft Permissive License. A 
 * copy of the license can be found in the License.html file at the root of this distribution. If 
 * you cannot locate the  Microsoft Permissive License, please send an email to 
 * ironruby@microsoft.com. By using this source code in any fashion, you are agreeing to be bound 
 * by the terms of the Microsoft Permissive License.
 *
 * You must not remove this notice, or any other, from this software.
 *
 *
 * ***************************************************************************/

using System;
using System.Diagnostics;

using Microsoft.Scripting;
using MSA = Microsoft.Scripting.Ast;
using Ast = Microsoft.Scripting.Ast.Ast;

namespace Ruby.Compiler.AST {
    public abstract class Variable : LeftValue {
        private SymbolId _name;

        public SymbolId Name {
            get { return _name; }
        }

        public Variable(SymbolId name, SourceSpan location)
            : base(location) {
            this._name = name;
        }

        public MSA.Expression/*!*/ TransformName(AstGenerator/*!*/ gen) {
            return Ast.Constant(SymbolTable.IdToString(_name));
        }

        public MSA.Expression/*!*/ TransformSymbolName(AstGenerator/*!*/ gen) {
            return Ast.Constant(_name);
        }
    }
}
