/* ****************************************************************************
 *
 * Copyright (c) Microsoft Corporation. 
 *
 * This source code is subject to terms and conditions of the Microsoft Permissive License. A 
 * copy of the license can be found in the License.html file at the root of this distribution. If 
 * you cannot locate the  Microsoft Permissive License, please send an email to 
 * ironruby@microsoft.com. By using this source code in any fashion, you are agreeing to be bound 
 * by the terms of the Microsoft Permissive License.
 *
 * You must not remove this notice, or any other, from this software.
 *
 *
 * ***************************************************************************/

using System;
using System.Collections.Generic;
using System.Text;
using Microsoft.Scripting;

namespace Ruby.Compiler.AST {

    // lhs.id op= rhs
    public class MemberAssignmentExpression : AssignmentExpression {
        private Node/*!*/ _lhs;
        private Node/*!*/ _rhs;
        private string/*!*/ _fieldName; // TODO
        private string/*!*/ _operation; // TODO

        public MemberAssignmentExpression(Node/*!*/ lhs, string/*!*/ fieldName, string/*!*/ operation, Node/*!*/ rhs, SourceSpan location)
            : base(location) {
            Utils.Assert.NotNull(lhs, fieldName, operation, rhs);

            _lhs = lhs;
            _fieldName = fieldName;
            _operation = operation;
            _rhs = rhs;
        }
    }
}
