/* ****************************************************************************
 *
 * Copyright (c) Microsoft Corporation. 
 *
 * This source code is subject to terms and conditions of the Microsoft Permissive License. A 
 * copy of the license can be found in the License.html file at the root of this distribution. If 
 * you cannot locate the  Microsoft Permissive License, please send an email to 
 * ironruby@microsoft.com. By using this source code in any fashion, you are agreeing to be bound 
 * by the terms of the Microsoft Permissive License.
 *
 * You must not remove this notice, or any other, from this software.
 *
 *
 * ***************************************************************************/

using System;
using System.Collections.Generic;
using System.Text;

namespace Ruby.Compiler.AST {
    public enum NodeIds {
        //                         Ruby.NET name           
        AliasStatement,                 // ALIAS, VALIAS,
        AssignmentExpression,           // ASSIGNMENT, OP_ASSGN
        MemberAssignmentExpression,     // OP_ASSGN2
        CALL,                           // CALL,
        MethodCall,                     // METHOD_CALL,
        
        AMPER,                          // AMPER,
        AND,                            // AND,
        ARGS,                           // ARGS,
        ArrayConstructor,               // ARRAY,
        ARRAY_ACCESS,                   // ARRAY_ACCESS,
        ATTRIBUTE,                      // ATTRIBUTE,
        BACK_REF,                       // BACK_REF,
        BEGIN,                          // BEGIN,
        begin,                          // begin,
                                        // BigNum,
        BLOCK,                          // BLOCK,
                                        // BLOCKARGS (removed)
        BREAK,                          // BREAK,
        CASE,                           // CASE,
        CLASS,                          // CLASS,
        CLASS_OR_MODULE,                // CLASS_OR_MODULE,
        CONCAT,                         // CONCAT,
        CONST,                          // CONST,
        ControlFlowNode,                // ControlFlowNode,
        CVAR,                           // CVAR,
        DEFINED,                        // DEFINED,
        DEFN,                           // DEFN,
        DEFS,                           // DEFS,
        DOT2,                           // DOT2,
        DOT3,                           // DOT3,
        DummyParam,                     // DummyParam,
        DynamicLocalVar,                // DynamicLocalVar,
        DynamicOuterVar,                // DynamicOuterVar,
        END,                            // END,
        EVAL_CODE,                      // EVAL_CODE,
        FOR,                            // FOR,
                                        // FORBODY (removed)
        FORMALS,                        // FORMALS,
        GetWhile,                       // GetWhile,
        GVAR,                           // GVAR,
        HASH,                           // HASH,
        IF,                             // IF,
        IVAR,                           // IVAR,
        LHS_STAR,                       // LHS_STAR,
        ListGen,                        // ListGen,
        LOCAL,                          // LOCAL,
        LVALUE,                         // LVALUE,
        MATCH,                          // MATCH,
        MLHS,                           // MLHS,
        MODULE,                         // MODULE,
        MultipleRHS,                    // MultipleRHS,
        NEXT,                           // NEXT,
        Node,                           // Node,
        NOT,                            // NOT,
        NTH_REF,                        // NTH_REF,
        OP_ASGN,                        // OP_ASGN,
        OP_ASGN2,                       // OP_ASGN2,
        OR,                             // OR,
        PARAM,                          // PARAM,
        PostTestLoop,                   // PostTestLoop,
        PreTestLoop,                    // PreTestLoop,
        PROGRAM,                        // PROGRAM,
        REDO,                           // REDO,
        REGEXP,                         // REGEXP,
        RESCUE_CLAUSE,                  // RESCUE_CLAUSE,
        RescueStatement,                // RESCUE_EXPR,
        RETRY,                          // RETRY,
        RETURN,                         // RETURN,
        SCLASS,                         // SCLASS,
        Scope,                          // Scope,
        SELF,                           // SELF,
        StaticLocalVar,                 // StaticLocalVar,
        StaticOuterVar,                 // StaticOuterVar,
        SUPER,                          // SUPER,
        SYMBOL,                         // SYMBOL,
        TRY_BLOCK,                      // TRY_BLOCK,
        UNDEF,                          // UNDEF,
        Literal,                        // VALUE,
                                        // FALSE,
                                        // TRUE,
                                        // NIL,
        VAR,                            // VAR,
        WHEN,                           // WHEN,
        XSTRING,                        // XSTRING,
        YIELD,                          // YIELD,

    }
}
