/* ****************************************************************************
 *
 * Copyright (c) Microsoft Corporation. 
 *
 * This source code is subject to terms and conditions of the Microsoft Permissive License. A 
 * copy of the license can be found in the License.html file at the root of this distribution. If 
 * you cannot locate the  Microsoft Permissive License, please send an email to 
 * ironruby@microsoft.com. By using this source code in any fashion, you are agreeing to be bound 
 * by the terms of the Microsoft Permissive License.
 *
 * You must not remove this notice, or any other, from this software.
 *
 *
 * ***************************************************************************/

using System;
using System.Collections.Generic;
using System.Text;
using System.Diagnostics;
using Microsoft.Scripting;

namespace Ruby.Compiler.AST {
    public sealed class AliasStatement : Statement {
        private SymbolId _lhsName;
        private SymbolId _rhsName;
        private LexicalScope _scope;

        /// <summary>
        /// Scope is null for global variables.
        /// </summary>
        public AliasStatement(LexicalScope scope, SymbolId lhsName, SymbolId rhsName, SourceSpan location)
            : base(location) {
            Debug.Assert(lhsName != null && rhsName != null);

            this._lhsName = lhsName;
            this._rhsName = rhsName;
            this._scope = scope;
        }
    }
}
