/* ****************************************************************************
 *
 * Copyright (c) Microsoft Corporation. 
 *
 * This source code is subject to terms and conditions of the Microsoft Permissive License. A 
 * copy of the license can be found in the License.html file at the root of this distribution. If 
 * you cannot locate the  Microsoft Permissive License, please send an email to 
 * ironruby@microsoft.com. By using this source code in any fashion, you are agreeing to be bound 
 * by the terms of the Microsoft Permissive License.
 *
 * You must not remove this notice, or any other, from this software.
 *
 *
 * ***************************************************************************/

using System;
using System.Diagnostics;

using MSA = Microsoft.Scripting.Ast;
using Ast = Microsoft.Scripting.Ast.Ast;

namespace Ruby.Compiler.AST {
    public class ExpressionStatement : Statement {
        private Expression/*!*/ _expression;

        public Expression/*!*/ Expression { get { return _expression; } }
        
        public ExpressionStatement(Expression/*!*/ expression) 
            : base(expression.Location) {
            Debug.Assert(expression != null);

            _expression = expression;
        }

        public override MSA.Statement Transform(AstGenerator/*!*/ gen) {
            return Ast.Statement(_expression.TransformRead(gen));
        }
    }
}
