/* ****************************************************************************
 *
 * Copyright (c) Microsoft Corporation. 
 *
 * This source code is subject to terms and conditions of the Microsoft Permissive License. A 
 * copy of the license can be found in the License.html file at the root of this distribution. If 
 * you cannot locate the  Microsoft Permissive License, please send an email to 
 * ironruby@microsoft.com. By using this source code in any fashion, you are agreeing to be bound 
 * by the terms of the Microsoft Permissive License.
 *
 * You must not remove this notice, or any other, from this software.
 *
 *
 * ***************************************************************************/

using System;

using Microsoft.Scripting;
using MSA = Microsoft.Scripting.Ast;
using System.Collections.Generic;

namespace Ruby.Compiler.AST {
    public abstract class Statement : Node {
        internal static readonly List<Statement>/*!*/ EmptyList = new List<Statement>();

        protected Statement(SourceSpan location)
            : base(location) {
        }

        public virtual MSA.Statement/*!*/ Transform(AstGenerator/*!*/ gen) {
            throw new NotImplementedException("Statement transformation not implemented");
        }
    }
}
