/* ****************************************************************************
 *
 * Copyright (c) Microsoft Corporation. 
 *
 * This source code is subject to terms and conditions of the Microsoft Permissive License. A 
 * copy of the license can be found in the License.html file at the root of this distribution. If 
 * you cannot locate the  Microsoft Permissive License, please send an email to 
 * ironruby@microsoft.com. By using this source code in any fashion, you are agreeing to be bound 
 * by the terms of the Microsoft Permissive License.
 *
 * You must not remove this notice, or any other, from this software.
 *
 *
 * ***************************************************************************/

using System;
using System.Collections.Generic;
using System.Text;
using Microsoft.Scripting;

namespace Ruby.Compiler.AST {

    public class UndefineStatement : Statement {
        private readonly LexicalScope/*!*/ _scope;
        private readonly List<UndefinedItem>/*!*/ _items;

        public UndefineStatement(LexicalScope/*!*/ scope, List<UndefinedItem>/*!*/ items, SourceSpan location)
            : base(location) {
            Utils.Assert.NotNull(scope, items);

            _scope = scope;
            _items = items;
        }
    }

    public struct UndefinedItem {
        private readonly SymbolId _identifier;
        private readonly SourceSpan _location;

        public UndefinedItem(SymbolId identifier, SourceSpan location) {
            _identifier = identifier;
            _location = location;
        }
    }
}
