/* ****************************************************************************
 *
 * Copyright (c) Microsoft Corporation. 
 *
 * This source code is subject to terms and conditions of the Microsoft Permissive License. A 
 * copy of the license can be found in the License.html file at the root of this distribution. If 
 * you cannot locate the  Microsoft Permissive License, please send an email to 
 * ironruby@microsoft.com. By using this source code in any fashion, you are agreeing to be bound 
 * by the terms of the Microsoft Permissive License.
 *
 * You must not remove this notice, or any other, from this software.
 *
 *
 * ***************************************************************************/

using System;
using System.Collections.Generic;
using System.Text;
using Microsoft.Scripting;
using System.Diagnostics;


namespace Ruby.Compiler.AST {
    public class WhileLoopStatement : Statement {
        //	until cond
        //		body
        //	end

        private Expression _cond;
        private Statement _body;		// optional
        private LexicalScope _parent_scope;
        private bool _isWhileLoop;
        private bool _isPostTest;

        public WhileLoopStatement(LexicalScope parent_scope, Expression cond, bool isPostTest, bool isWhileLoop, Statement body, SourceSpan location)
            : base(location) {
            this._parent_scope = parent_scope;
            this._cond = cond;
            this._isWhileLoop = isWhileLoop;
            this._body = body;
            this._isPostTest = isPostTest;
        }
    }
}
