/* ****************************************************************************
 *
 * Copyright (c) Microsoft Corporation. 
 *
 * This source code is subject to terms and conditions of the Microsoft Permissive License. A 
 * copy of the license can be found in the License.html file at the root of this distribution. If 
 * you cannot locate the  Microsoft Permissive License, please send an email to 
 * ironruby@microsoft.com. By using this source code in any fashion, you are agreeing to be bound 
 * by the terms of the Microsoft Permissive License.
 *
 * You must not remove this notice, or any other, from this software.
 *
 *
 * ***************************************************************************/

using System;
using System.Collections.Generic;
using System.Text;
using Microsoft.Scripting;

namespace Ruby.Compiler {
    internal static class Symbols {
        // TODO:
        public static readonly SymbolId None = SymbolTable.StringToId("");
        public static readonly SymbolId RestArgsLocal = SymbolTable.StringToId("?rest?");
        public static readonly SymbolId ExceptionHolder = SymbolTable.StringToId("#exception");
        
        public static readonly SymbolId Self = SymbolTable.StringToId("self");
        public static readonly SymbolId Nil = SymbolTable.StringToId("nil");
        public static readonly SymbolId True = SymbolTable.StringToId("true");
        public static readonly SymbolId False = SymbolTable.StringToId("false");
        public static readonly SymbolId File = SymbolTable.StringToId("__FILE__");
        public static readonly SymbolId Line = SymbolTable.StringToId("__LINE__");

        public static readonly SymbolId MethodMissing = SymbolTable.StringToId("method_missing");
        public static readonly SymbolId Initialize = SymbolTable.StringToId("initialize");
        public static readonly SymbolId Object = SymbolTable.StringToId("Object");
        public static readonly SymbolId Kernel = SymbolTable.StringToId("Kernel");

        
        public static readonly SymbolId Context = SymbolTable.StringToId("context");
        public static readonly SymbolId Each = SymbolTable.StringToId("each");
        public static readonly SymbolId Colon = SymbolTable.StringToId(":");
        public static readonly SymbolId DoubleQuote = SymbolTable.StringToId("\"");
        public static readonly SymbolId Comma = SymbolTable.StringToId(",");
        public static readonly SymbolId Semicolon = SymbolTable.StringToId(";");
        public static readonly SymbolId ForwardSlash = SymbolTable.StringToId("/");

        public static readonly SymbolId DoubleDot = SymbolTable.StringToId("..");
        public static readonly SymbolId TripleDot = SymbolTable.StringToId("...");
        public static readonly SymbolId DoubleStar = SymbolTable.StringToId("**");
        public static readonly SymbolId UnaryPlus = SymbolTable.StringToId("+@");
        public static readonly SymbolId UnaryMinus = SymbolTable.StringToId("-@");
        public static readonly SymbolId Comparison = SymbolTable.StringToId("<=>");
        public static readonly SymbolId GreaterEqual = SymbolTable.StringToId(">=");
        public static readonly SymbolId LessEqual = SymbolTable.StringToId("<=");
        public static readonly SymbolId Equal = SymbolTable.StringToId("==");
        public static readonly SymbolId StrictEqual = SymbolTable.StringToId("===");
        public static readonly SymbolId NotEqual = SymbolTable.StringToId("!=");
        public static readonly SymbolId Match = SymbolTable.StringToId("=~");
        public static readonly SymbolId NotMatch = SymbolTable.StringToId("!~");
        public static readonly SymbolId ArrayItemRead = SymbolTable.StringToId("[]");
        public static readonly SymbolId ArrayItemWrite = SymbolTable.StringToId("[]=");
        public static readonly SymbolId LeftShift = SymbolTable.StringToId("<<");
        public static readonly SymbolId RightShift = SymbolTable.StringToId(">>");
        public static readonly SymbolId DoubleColon = SymbolTable.StringToId("::");
        public static readonly SymbolId Or = SymbolTable.StringToId("||");
        public static readonly SymbolId And = SymbolTable.StringToId("&&");

        public static readonly SymbolId Bang = SymbolTable.StringToId("!");
        public static readonly SymbolId UnderscoreGlobalVariable = SymbolTable.StringToId("$_"); // TODO: remove $
        
    }
}