/* ****************************************************************************
 *
 * Copyright (c) Microsoft Corporation. 
 *
 * This source code is subject to terms and conditions of the Microsoft Permissive License. A 
 * copy of the license can be found in the License.html file at the root of this distribution. If 
 * you cannot locate the  Microsoft Permissive License, please send an email to 
 * ironruby@microsoft.com. By using this source code in any fashion, you are agreeing to be bound 
 * by the terms of the Microsoft Permissive License.
 *
 * You must not remove this notice, or any other, from this software.
 *
 *
 * ***************************************************************************/

using System;
using System.Collections.Generic;
using System.Text;
using Microsoft.Scripting;
using System.Reflection.Emit;
using System.Reflection;

namespace Ruby.Runtime {
    public enum BlockReturnReason {
        Undefined = 0,
        BreakOrRetry, // so far, we don't need to distinguish among break and retry (we can save one comparison by unifying them)
        Next,
        Redo
    }

    // TODO: remove when DLR supports out parameters
    public class BlockReturnReasonHolder {
        public BlockReturnReason Value;

        internal static FieldInfo/*!*/ ValueField { get { return typeof(BlockReturnReasonHolder).GetField("Value"); } }

        internal static ConstructorInfo/*!*/ Constructor {
            get { return typeof(BlockReturnReasonHolder).GetConstructor(Type.EmptyTypes); }
        }
        
        public BlockReturnReasonHolder() {
        }

        public bool IsBreak() {
            return Value == BlockReturnReason.BreakOrRetry;
        }
    }

}
