#####################################################################################
#
#  Copyright (c) Microsoft Corporation. All rights reserved.
#
# This source code is subject to terms and conditions of the Microsoft Permissive License. A 
# copy of the license can be found in the License.html file at the root of this distribution. If 
# you cannot locate the  Microsoft Permissive License, please send an email to 
# ironruby@microsoft.com. By using this source code in any fashion, you are agreeing to be bound 
# by the terms of the Microsoft Permissive License.
#
# You must not remove this notice, or any other, from this software.
#
#
#####################################################################################
require '../../util/assert.rb'

# Array.new: empty new array
x = Array.new
assert_equal(x.length, 0)

# Array.new(size=0, obj=nil): array with size copies of obj. (references to the same obj)
assert_raise(ArgumentError) { Array.new(-1) }

x = Array.new(0)
assert_equal(x.length, 0)

x = Array.new(1)
assert_equal(x.length, 1)

x = Array.new(3, 10)
assert_equal(x.length, 3)
assert_equal(x[0], 10)
assert_equal(x[9], 10)

y = [1, 2, 3]
x = Array.new(4, y)
assert_equal(x[0], y)
x[1][2] = 20
assert_equal(y[2], 20)

# Array.new(array): calling to_ary on the parameter

# Array.new(size) {|i| block}

