#####################################################################################
#
#  Copyright (c) Microsoft Corporation. All rights reserved.
#
# This source code is subject to terms and conditions of the Microsoft Permissive License. A 
# copy of the license can be found in the License.html file at the root of this distribution. If 
# you cannot locate the  Microsoft Permissive License, please send an email to 
# ironruby@microsoft.com. By using this source code in any fashion, you are agreeing to be bound 
# by the terms of the Microsoft Permissive License.
#
# You must not remove this notice, or any other, from this software.
#
#
#####################################################################################
require "../../util/simple_test.rb"

describe "inspect object attributes" do
  it "asserts object identity for built-in types" do
    3.object_id.should == 3.object_id
    3.object_id.should_not == 4.object_id

    a, b = [], []
    a.object_id.should_not == b.object_id
  end

  it "tests for well-known object_id values" do
    nil.object_id.should == 4
    true.object_id.should == 2
    false.object_id.should == 0
    0.object_id.should == 1
    1.object_id.should == 3
    2.object_id.should == 5
    -1.object_id.should == -1
    -2.object_id.should == -3
  end

  it "tests for nil objects" do
    3.nil?.should == false
    nil.nil?.should == true
    [].nil?.should == false
  end

  it "converts well-known object to strings" do
    true.to_s.should == "true"
    false.to_s.should == "false"
    nil.to_s.should == ""
  end
end

# TODO: must implement is_a?
#test "kind_of? and is_a? tests on well-known types" do
#  assert 3.is_a? Fixnum
#  assert 3.is_a? Integer
#  assert 3.is_a? Numeric
#  assert 3.is_a? Object
#end
