#####################################################################################
#
#  Copyright (c) Microsoft Corporation. All rights reserved.
#
# This source code is subject to terms and conditions of the Microsoft Permissive License. A 
# copy of the license can be found in the License.html file at the root of this distribution. If 
# you cannot locate the  Microsoft Permissive License, please send an email to 
# ironruby@microsoft.com. By using this source code in any fashion, you are agreeing to be bound 
# by the terms of the Microsoft Permissive License.
#
# You must not remove this notice, or any other, from this software.
#
#
#####################################################################################
require '../../util/assert.rb'

# test const

TOP_LEVEL_CONST = 2

assert_equal(TOP_LEVEL_CONST, 2)
assert_equal(Object::TOP_LEVEL_CONST, 2)

def check
    assert_equal(TOP_LEVEL_CONST, 2)
end 

check

class My_const
    CONST = 1
    def check
        assert_equal(TOP_LEVEL_CONST, 2)
        assert_equal(Object::TOP_LEVEL_CONST, 2)
        
        assert_equal(CONST, 1)
        assert_equal(My_const::CONST, 1)
    end
end 

x = My_const.new

assert_equal(My_const::CONST, 1)
assert_raise(NoMethodError) { x.CONST }  # undefined method `CONST' for #<My:0x764e9a0> (NoMethodError)
assert_raise(TypeError) { x::CONST }  # #<My:0x75cf2b8> is not a class/module (TypeError)

x.check