#####################################################################################
#
#  Copyright (c) Microsoft Corporation. All rights reserved.
#
# This source code is subject to terms and conditions of the Microsoft Permissive License. A 
# copy of the license can be found in the License.html file at the root of this distribution. If 
# you cannot locate the  Microsoft Permissive License, please send an email to 
# ironruby@microsoft.com. By using this source code in any fashion, you are agreeing to be bound 
# by the terms of the Microsoft Permissive License.
#
# You must not remove this notice, or any other, from this software.
#
#
#####################################################################################

require '../../util/assert.rb'

# left side of assignment may contain a parenthesized list of terms.
# it extracts the corresponding rvalue, assigning it to the parenthesized terms, before continuing
# with higher-level assignment.

# (a) = 3: syntax error

(a, ) = 3
assert_equal(a, 3)

(a, ) = 4, 7
assert_equal(a, 4)

(a, b) = 5
assert_equal(a, 5)
assert_nil(b)

(a, b) = 6, 7
assert_equal(a, 6)
assert_equal(b, 7)

(a, b) = 8, 9, 10
assert_equal(a, 8)
assert_equal(b, 9)

(a, b) = [5]
assert_equal(a, 5)
assert_nil(b)

(a, b) = [6, 7]
assert_equal(a, 6)
assert_equal(b, 7)

(a, b) = [6], 7
assert_equal(a, [6])
assert_equal(b, 7)

(a, b) = 8, [9, 10]
assert_equal(a, 8)
assert_equal(b, [9, 10])

(a, b), c = 5
assert_equal(a, 5)
assert_nil(b)
assert_nil(c)

(a, b), c = 6, 7
assert_equal(a, 6)
assert_nil(b)
assert_equal(c, 7)

(a, b), c = 8, 9, 10
assert_equal(a, 8)
assert_nil(b)
assert_equal(c, 9)

(a, b), c = [-8, -9], -10
assert_equal(a, -8)
assert_equal(b, -9)
assert_equal(c, -10)

# gotcha
(a, b), c = [8, 9, 10]
assert_equal(a, 8)
assert_nil(b)
assert_equal(c, 9)

(a, b), c = -8, [-9, -10]
assert_equal(a, -8)
assert_nil(b)
assert_equal(c, [-9, -10])
