/* ****************************************************************************
 *
 * Copyright (c) Microsoft Corporation. 
 *
 * This source code is subject to terms and conditions of the Microsoft Permissive License. A 
 * copy of the license can be found in the License.html file at the root of this distribution. If 
 * you cannot locate the  Microsoft Permissive License, please send an email to 
 * ironruby@microsoft.com. By using this source code in any fashion, you are agreeing to be bound 
 * by the terms of the Microsoft Permissive License.
 *
 * You must not remove this notice, or any other, from this software.
 *
 *
 * ***************************************************************************/

using System;
using System.Reflection;
using System.Reflection.Emit;

using Ruby.Hosting;
using Ruby.Compiler;
using Ruby.Compiler.AST;

using Microsoft.Scripting;
using MSA = Microsoft.Scripting.Ast;
using Microsoft.Scripting.Hosting;
using Microsoft.Scripting.Generation;

internal sealed class RubyConsoleHost : ConsoleHost {

    protected override void Initialize() {
        base.Initialize();
        this.Options.LanguageProvider = ScriptEnvironment.GetEnvironment().GetLanguageProvider(typeof(RubyLanguageProvider));
    }

    [STAThread]
    static int Main(string[] args) {
        int result = new RubyConsoleHost().Run(args);
        ScriptDomainManager.CurrentManager.Snippets.Dump(@"snippets.dll");
        return result;
    }
}